      SUBROUTINE ACCEL (PSI,D,HLP)
      INCLUDE 'TYPES.INC'

***   ACCEL - ACCELERATE CONVERGENCE
*
*     S.SELBERHERR   1979-1986
*
      INCLUDE 'CMOS02X.INC'
      INCLUDE 'CMEMX.INC'
      DIMENSION PSI(NXYTOT),D(NXYTOT),HLP(NXYTOT),
     1AMP((MAXIPM*(MAXIPM+1))/2),ZMP(MAXIPM)

**    START OF EXECUTABLE CODE
*     ************************
*
      CALL SLTPUT (PSI,IPSI,NXYTOT)

      IPMPT=MOD(IPMPT,MAXIPM)+1
      IF (IPM.EQ.MAXIPM) PMPH=PMP(1,IPMPT)
      PMP(1,IPMPT)=DOTPRO(D,D,NXYTOT)
      DO 1 I=1,IPM
      JPMPT=IPMPT-I
      IF (JPMPT.LE.0) JPMPT=JPMPT+IPM
      CALL SLTGET (HLP,IDSTK(JPMPT),NXYTOT)
 1    PMP(I+1,IPMPT)=DOTPRO(D,HLP,NXYTOT)

      K=0
      DO 2 J=1,IPM
      DO 2 I=1,J
      K=K+1
      IF (I.EQ.MAXIPM) THEN
         AMP(K)=PMPH
      ELSE
         I1=IPMPT-I
         IF (I1.LE.0) I1=I1+IPM
         AMP(K)=PMP(J-I+1,I1)
      ENDIF
 2    AMP(K)=AMP(K)+PMP(1,IPMPT)-PMP(I+1,IPMPT)-PMP(J+1,IPMPT)

      JJ=0
      DO 5 J=1,IPM
      S=0
      KJ=JJ
      KK=0
      DO 4 K=1,J-1
      KJ=KJ+1
      T=AMP(KJ)
      DO 3 I=1,K-1
 3    T=T-AMP(KK+I)*AMP(JJ+I)
      KK=KK+K
      T=T/AMP(KK)
      AMP(KJ)=T
 4    S=S+T*T
      JJ=JJ+J
 5    AMP(JJ)=SQRT(AMP(JJ)-S)

      DO 6 I=1,IPM
 6    ZMP(I)=PMP(1,IPMPT)-PMP(I+1,IPMPT)

      KK=0
      DO 8 K=1,IPM
      T=0
      DO 7 I=1,K-1
 7    T=T+AMP(KK+I)*ZMP(I)
      KK=KK+K
 8    ZMP(K)=(ZMP(K)-T)/AMP(KK)
      DO 9 K=IPM,1,-1
      ZMP(K)=ZMP(K)/AMP(KK)
      KK=KK-K
      DO 9 I=1,K-1
 9    ZMP(I)=ZMP(I)-ZMP(K)*AMP(KK+I)

      H=1
      DO 10 I=1,IPM
 10   H=H-ZMP(I)

      DO 7701 L=1,NXYTOT
 7701 PSI(L)=H*PSI(L)

      DO 11 I=1,IPM
      JPMPT=IPMPT-I
      IF (JPMPT.LE.0) JPMPT=JPMPT+IPM
      CALL SLTGET (HLP,IYSTK(JPMPT),NXYTOT)
      DO 11 L=1,NXYTOT
 11   PSI(L)=PSI(L)+ZMP(I)*HLP(L)

      IPM=MIN(MAXIPM,IPM+1)

      I=IYSTK(IPMPT)
      IYSTK(IPMPT)=IPSI
      IPSI=I
      CALL SLTPUT (D,IDSTK(IPMPT),NXYTOT)

      END
      SUBROUTINE BIDIA (A,X,IDIR,N)
      INCLUDE 'TYPES.INC'

***   BIDIA - SOLVE BIDIAGONAL SYSTEM
*
*     S.SELBERHERR  1987
*
*     A      - OFF DIAGONAL ELEMENTS
*              ARRAY OF (N) ELEMENTS
*     X      - RIGHT HAND SIDE ON ENTRY
*              SOLUTION ON EXIT
*              ARRAY OF (N) ELEMENTS
*     IDIR   - DIRECTION INDICATOR
*              = +1 LOWER BIDIAGONAL SYSTEM
*              = -1 LOWER BIDIAGONAL SYSTEM
*     N      - RANK OF SYSTEM
*
*
*     THE MAIN DIAGONAL IS ASSUMED TO BE UNITY
*
*     THE NAIVE SUBSTITTUTION METHOD IS USED
*     WITH ROLLED LOOP TECHNIQUE
*
      DIMENSION A(N-1),X(N)

      IF (IDIR.EQ.1) THEN
         DO 1 I=2,N-7,8
         X(I  )=X(I  )-A(I-1)*X(I-1)
         X(I+1)=X(I+1)-A(I  )*X(I  )
         X(I+2)=X(I+2)-A(I+1)*X(I+1)
         X(I+3)=X(I+3)-A(I+2)*X(I+2)
         X(I+4)=X(I+4)-A(I+3)*X(I+3)
         X(I+5)=X(I+5)-A(I+4)*X(I+4)
         X(I+6)=X(I+6)-A(I+5)*X(I+5)
 1       X(I+7)=X(I+7)-A(I+6)*X(I+6)
         DO 2 I=I,N
 2       X(I)=X(I)-A(I-1)*X(I-1)
      ELSE
         DO 3 I=N-1,8,-8
         X(I  )=X(I  )-A(I  )*X(I+1)
         X(I-1)=X(I-1)-A(I-1)*X(I  )
         X(I-2)=X(I-2)-A(I-2)*X(I-1)
         X(I-3)=X(I-3)-A(I-3)*X(I-2)
         X(I-4)=X(I-4)-A(I-4)*X(I-3)
         X(I-5)=X(I-5)-A(I-5)*X(I-4)
         X(I-6)=X(I-6)-A(I-6)*X(I-5)
 3       X(I-7)=X(I-7)-A(I-7)*X(I-6)
         DO 4 I=I,1,-1
 4       X(I)=X(I)-A(I)*X(I+1)
      ENDIF

      END
      SUBROUTINE BNDPOI (E,A,C,F,NRANG)
      INCLUDE 'TYPES.INC'

***   BNDPOI - SET BOUNDARY CONDITIONS IN COEFFICIENT MATRIX
*              FOR POISSON EQUATION
*
*     S.SELBERHERR   1986
*
      INCLUDE 'CMOS02X.INC'
      DIMENSION E(NX,NYTOT),A(NX,NYTOT),C(NX,NYTOT),F(NX,NYTOT)

**    START OF EXECUTABLE CODE
*     ************************
*
*     SOURCE AND DRAIN CONTACTS
      DO 2 J=1,NYOX
      DO 1 I=1,NXS
      E(I,J)=-1
      A(I,J)=0
      C(I,J)=0
 1    F(I,J)=0
      DO 2 I=NXD,NX
      E(I,J)=-1
      A(I-1,J)=0
      C(I,J)=0
 2    F(I,J)=0

**    GATE CONTACT
      DO 3 J=1,NYG
      A(NXG1-1,J)=0
      DO 3 I=NXG1,NXG2
      E(I,J)=-1
      A(I,J)=0
      C(I,J)=0
 3    F(I,J)=0

**    SURFACE BETWEEN SOURCE AND GATE
      DO 4 I=NXS+1,NXG1-1
      E(I,1)=-1
      A(I,1)=0
      C(I,1)=0
 4    F(I,1)=0

**    SURFACE BETWEEN GATE AND DRAIN
      DO 5 I=NXG2+1,NXD-1
      E(I,1)=-1
      A(I,1)=0
      C(I,1)=0
 5    F(I,1)=0

**    SUBSTRATE CONTACT
      IF (.NOT.LBOTI) THEN
*        DIRICHLET
         DO 6 I=1,NX
 6       C(I,NYTOT-1)=0
         NRANG=NYTOT-1
      ELSE
*        NEUMANN
         NRANG=NYTOT
      ENDIF

      END
      SUBROUTINE EQPOI (PSI,A,C,E,F,A1,A2,A3,A4,ITLIN,LFRST)
      INCLUDE 'TYPES.INC'

***   EQPOI - SOLVE POISSON EQUATION
*
*     S.SELBERHERR   1986
*
      PARAMETER (UIMAX=0.01)
      INCLUDE 'CMSYSX.INC'
      INCLUDE 'CMDATX.INC'
      INCLUDE 'CMOS02X.INC'
      INCLUDE 'CMEMX.INC'
      DIMENSION PSI(NXYTOT),A(NXYTOT),C(NXYTOT),E(NXYTOT),F(NXYTOT),
     1A1(NXYTOT),A2(NXYTOT),A3(NXYTOT),A4(NXYTOT)

      OEXP(Z)=EXP(SIGN(MIN(ABS(Z),EXPLIM),Z))

**    START OF EXECUTABLE CODE
*     ************************
*
**    MINORITY CARRIER CONCENTRATION
      CALL SLTGET (A(NXYOX+1),ICC(1),NXY)
**    MAJORITY CARRIER CONCENTRATION
      CALL SLTGET (C(NXYOX+1),ICC(2),NXY)
**    DONOR AND ACCEPTOR CONCENTRATION
      CALL SLTGET (A1(NXYOX+1),ICDON,NXY)
      CALL SLTGET (A2(NXYOX+1),ICACC,NXY)
**    PREPARE RIGHT HAND SIDE AND SCALING FACTORS
      CALL CHARGE (F(NXYOX+1),A(NXYOX+1),C(NXYOX+1),A1(NXYOX+1),
     1A2(NXYOX+1),A3(NXYOX+1),E(NXYOX+1),.TRUE.)
      IF (ECMED.GE.0) CALL SLTGET (A1(NXYOX+1),ICDON,NXY)
      IF (EAMEV.GE.0) CALL SLTGET (A2(NXYOX+1),ICACC,NXY)

**    DISCRETIZATION AREAS
      CALL SLTGET (A3,IPOI(4),NXYOX+NXY)
      DO 7701 L=1,NXYOX
 7701 F(L)=0
      DO 7702 L=NXYSEM+1,NXYTOT
 7702 F(L)=0
      DO 7703 L=NXYOX+1,NXYSEM
      A4(L)=1/MAX(A1(L)+A2(L),A(L)+C(L))
      A1(L)=E(L)*A3(L)
 7703 F(L)=-F(L)*A3(L)

**    MAIN DIAGONAL
      CALL SLTGET (E,IPOI(3),NXYTOT)
      DO 7704 L=NXYOX+1,NXYSEM
 7704 E(L)=E(L)-A1(L)

**    UPDATE CURRENT BOUNDARY CONDITIONS
      IF ((RSOURC.NE.0.OR.RDRAIN.NE.0).AND.PNORM.LE.0.5) THEN
**       SOURCE VOLTAGE DUE TO CURRENT
         UISOO=UISO
         UISO=UISN
**       DESIRED VALUE
         UISN=(FLUXB(1)-FLUXB(2)+FLUXD(1)-FLUXD(2))*RSOURC
**       LIMITED VALUE
         UISN=UISO+SIGN(MIN(ABS(UISN-UISO),UIMAX/UT),UISN-UISO)
**       DAMP OSZILLATIONS
         IF((UISN-UISO)*(UISO-UISOO).LT.0) UISN=UISO+0.33*(UISN-UISO)

**       DRAIN VOLTAGE DUE TO CURRENT
         UIDOO=UIDO
         UIDO=UIDN
**       DESIRED VALUE
         UIDN=-(FLUXD(1)-FLUXD(2))*RDRAIN
**       LIMITED VALUE
         UIDN=UIDO+SIGN(MIN(ABS(UIDN-UIDO),UIMAX/UT),UIDN-UIDO)
**       DAMP OSZILLATIONS
         IF((UIDN-UIDO)*(UIDO-UIDOO).LT.0) UIDN=UIDO+0.33*(UIDN-UIDO)

**       UPDATE POTENTIAL BOUNDARIES
         CALL BNDVAL (PSI,A(NXYOX+1),C(NXYOX+1),DUMMY,.FALSE.)
      ENDIF

**    IF FIXED SURFACE STATES
      IF (CISS.NE.0) THEN
**       GAUSSIAN DISTRIBUTED
         DO 1 L=NXS+1,NXD-1
 1       F(L+NXYOX)=F(L+NXYOX)-ICHANL*CISS*DXM(L)*
     1   OEXP(-((X(L)-XISS)/SISS)**2)
      ENDIF
      IF (SNSS.NE.0) THEN
**       CONSTANT
         DO 7705 L=NXS+1,NXD-1
 7705    F(L+NXYOX)=F(L+NXYOX)-ICHANL*SNSS*DXM(L)
      ENDIF
**    FAST CHARGABLE SURFACE STATES
      IF (SFSS.NE.0) THEN
         H=EGAP/2+UT*LOG(CINTR)
         DO 2 L=NXS+1,NXD-1
 2       F(L+NXYOX)=F(L+NXYOX)-ICHANL*SFSS*DXM(L)*
     1   (H-UT*LOG(A(L+NXYOX)))
      ENDIF

**    IF FIXED SURFACE STATES AT SUBSTRATE INSULATOR
      IF (RPS.NE.0.AND.LBOTI) THEN
         DO 7706 L=1,NX
 7706    F(L+NXYSEM-NX)=F(L+NXYSEM-NX)-ICHANL*RPS*DXM(L)
      ENDIF

**    SUB/SUP DIAGONAL
      CALL SLTGET (A,IPOI(1),NXYTOT)
**    SUPER-SUB/SUPER-SUP DIAGONAL
      CALL SLTGET (C,IPOI(2),NXYTOT)

**    ADD LAPLACIAN TO RIGHT HAND SIDE
      DO 7707 L=1,NXYTOT-1
      H=A(L)*(PSI(L+1)-PSI(L))
      F(L)=F(L)-H
 7707 F(L+1)=F(L+1)+H
      DO 7708 L=1,NXYTOT-NX
      H=C(L)*(PSI(L+NX)-PSI(L))
      F(L)=F(L)-H
 7708 F(L+NX)=F(L+NX)+H

**    BOUNDARY CONDITIONS
      CALL BNDPOI (E,A,C,F,NRANG)

**    MAX-NORM AND L2-NORM OF POISSON RESIDUAL
      IF (NT.EQ.NY.AND..NOT.LBOTI) THEN
         NXYA=NXYOX+NXTMX
      ELSE
         NXYA=NXYOX+NXT
      ENDIF
      AREA=0
      DO 7709 L=1,NXYOX
      AREA=AREA+A3(L)
      A1(L)=ABS(F(L))/A3(L)
 7709 A2(L)=F(L)**2/A3(L)
      DO 7710 L=NXYOX+1,NXYA
      AREA=AREA+A3(L)
      A1(L)=ABS(F(L)*A4(L))/A3(L)
 7710 A2(L)=(F(L)*A4(L))**2/A3(L)
      H=TINS*TINS/(EINS/ESEM*MAX(ABS(UG-US),ABS(UG-UF),ABS(UG-UD)))
      PNORMI=0
      PNOR2I=0
      DO 7711 L=1,NXYOX
      PNORMI=MAX(PNORMI,A1(L))
 7711 PNOR2I=PNOR2I+A2(L)
      PNORMI=PNORMI*H
      PNOR2I=PNOR2I*H*H
      DO 7712 L=NXYOX+1,NXYA
      PNORMI=MAX(PNORMI,A1(L))
 7712 PNOR2I=PNOR2I+A2(L)
      PNOR2I=SQRT(PNOR2I/AREA)

**    IF IT MUST CONVERGE EVEN IF IT DOES NOT LOOK SO
      IF (IPM.EQ.0) GOTO 4
**    IF EVERYTHING CONVERGES PROPERLY
      IF (PNORMI.LT.PNORM.OR.PNOR2I.LT.PNOR2) GOTO 4
**    IF IT DOES NOT CONVERGE BUT NOTHING CAN BE DONE
      IF (IPM.EQ.1) GOTO 3

**    ACCELERATION PROBABLY RESPONSIBLE FOR LACK OF CONVERGENCE
*     RESTORE BY POINTERS ONLY
      I=IYSTK(IPMPT)
      IYSTK(IPMPT)=IPSI
      IPSI=I
      CALL SLTGET (PSI,IPSI,NXYTOT)
      IPM=0
      IPMPT=0
      ITCYC=ITCYC-1
      GOTO 7

**    LOCALLY DIVERGING
 3    IPM=0
      IPMPT=0
 4    PNORM=PNORMI
      PNOR2=PNOR2I

**    IF WE MUST SOLVE AGAIN
      H=0.1*MAX(ABS(UIDN-UIDO),ABS(UISN-UISO))*UT
      IF (MAX(PNORM,H,PNORMD(1),PNORMD(2)).GT.ERROR.OR.LFRST) GOTO 5
      PNORMD(3)=0
      ITLIN=0
      GOTO 7

**    SOLVE LINEAR SYSTEM
 5    CALL SOLVSY (E(NX+1),A(NX+1),C(NX+1),F(NX+1),A1,A2,A3,A4,NX,
     1NRANG-1,ITLIN)

**    COMPUTE MAX-NORM OF INCREMENTS, DAMP EVENTUALLY AND UPDATE PSI
      PNORMD(3)=0
      DO 6 L=NX+1,NX*NRANG
      H=ABS(F(L))
      PNORMD(3)=MAX(PNORMD(3),H)
**    YOU WILL NEVER FIND OUT HOW THIS HAS BEEN DERIVED
      IF (H.GT.1) THEN
         IF (H.GT.18.073) THEN
            F(L)=SIGN(3.5*LOG(H),F(L))
         ELSE
            F(L)=SIGN(H**0.8,F(L))
         ENDIF
      ENDIF
 6    PSI(L)=PSI(L)+F(L)

**    IF WE SHOULD TRY TO ACCELERATE
      H=0.1*MAX(ABS(UIDN-UIDO),ABS(UISN-UISO))*UT
      IF (MAX(PNORMD(1),PNORMD(2),PNORMD(3)).LT.0.98.AND.
     1(IMODEL.NE.4.OR..NOT.LBOTI).AND.H.LE.ERROR) THEN
         DO 7713 L=1,NX
 7713    F(L)=0
         DO 7714 L=NX*NRANG+1,NXYTOT
 7714    F(L)=0
**       ACCELERATE
         CALL ACCEL (PSI,F,A)
      ELSE
         IPM=0
         IPMPT=0
      ENDIF

**    SAVE NEW ELECTROSTATIC POTENTIAL
      CALL SLTPUT (PSI,IPSI,NXYTOT)
      LFRST=.FALSE.

7     RETURN
      END
      SUBROUTINE SOLVSY (E,A,C,F,H1,H2,H3,H4,MX,MY,IT)
      INCLUDE 'TYPES.INC'

***   SOLVSY - SOLVE SYMMETRIC LINEAR 5-POINT STAR SYSTEM
*
*     S.SELBERHERR   1986
*
      DIMENSION E(MX*MY),A(MX*MY),C(MX*MY),F(MX*MY),H1(MX*MY),H2(MX*MY),
     1H3(MX*MY),H4(MX*MY)

**    START OF EXECUTABLE CODE
*     ************************
*
      CALL SWAPB (F,H1,MX,MY)
      CALL SWAPB (A,F,MX,MY)
      CALL SWAPB (C,A,MX,MY)
      CALL SWAPB (E,C,MX,MY)
      NR=((MY+1)/2)*MX
      NB=MX*MY-NR
      IF (NB.EQ.NR) THEN
         CALL CJCG1(F,F(NR+1),A,A(NR+1),C,C(NR+1),H1,H1(NR+1),E,E(NR+1),
     1   H2,H2(NR+1),H3,H3(NR+1),MX,NB,IT)
      ELSE
         CALL CJCG2(F,F(NR+1),A,A(NR+1),C,C(NR+1),H1,H1(NR+1),E,E(NR+1),
     1   H2,H2(NR+1),H3,H3(NR+1),MX,NR,NB,IT)
      ENDIF
      CALL SWAPBB (F,E,MX,MY)

      END
      SUBROUTINE SWAPB (A,B,N,M)
      INCLUDE 'TYPES.INC'

***   SWAPB - PERMUTE TO BLOCK RED/BLACK SYSTEM
*
*     S.SELBERHERR   1979-1987
*
      DIMENSION A(N,M),B(N,M)

      K=0
      DO 1 I=1,2
      DO 1 J=I,M,2
      K=K+1
      DO 1 L=1,N
 1    B(L,K)=A(L,J)
      RETURN


      ENTRY SWAPBB (A,B,N,M)

***   SWAPBB - PERMUTE FROM BLOCK RED/BLACK SYSTEM
*
      K=0
      DO 2 I=1,2
      DO 2 J=I,M,2
      K=K+1
      DO 2 L=1,N
 2    A(L,J)=B(L,K)

      END
      SUBROUTINE TRIFAC (E,A,F,N)
      INCLUDE 'TYPES.INC'

***   TRIFAC - FACTORIZE SYMMETRIC TRIDIAGONAL SYSTEM
*
*     S.SELBERHERR   1987
*
      DIMENSION E(N),A(N-1),F(N)

      M=(N-1)/2
      K=M+2-MOD(N,2)
      F(1)=E(1)
      F(N)=E(N)
**    FACTORIZATION FROM BOTH ENDS TO THE CENTER
      DO 1 I=2,K
 1    F(I)=E(I)-A(I-1)**2/F(I-1)
      DO 2 I=N-1,K+1,-1
 2    F(I)=E(I)-A(I)**2/F(I+1)
**    TREAT CENTER EXPLICITELY
      F(K)=E(K)-A(K)**2/F(K+1)-A(K-1)**2/F(K-1)
**    COMPUTE RECIPROCALS OF FACTORIZATION COEFFICIENTS
      DO 7701 L=1,N
 7701 F(L)=1/F(L)
**    ADJUST OFF-DIAGONAL FACTORS
      DO 7702 L=1,K-1
 7702 A(L)=A(L)*F(L)
      DO 7703 L=K,N-1
 7703 A(L)=A(L)*F(L+1)

      END
      SUBROUTINE TRISOL (A,X,F,N)
      INCLUDE 'TYPES.INC'

***   TRISOL - SOLVE SYMMETRIC TRIDIAGONAL SYSTEM
*
*     S.SELBERHERR   1987
*
      DIMENSION A(N-1),X(N),F(N)

      M=(N-1)/2
      K=M+2-MOD(N,2)
**    FORWARD SUBSTITUTION FROM BOTH ENDS TO THE CENTER
      DO 8 J=1,2
      IF (J.EQ.1) THEN
         CALL BIDIA (A,X,1,K-1)
      ELSEIF (J.EQ.2) THEN
         CALL BIDIA (A(K+1),X(K+1),-1,N-K)
      ENDIF
 8    CONTINUE
**    TREAT CENTER EXPLICITELY
      X(K)=X(K)-X(K+1)*A(K)-X(K-1)*A(K-1)
**    MAIN DAIGONAL OF FACTORS
      DO 7701 L=1,N
 7701 X(L)=X(L)*F(L)
**    BACKWARD SUBSTITUTION FROM THE CENTER TO BOTH ENDS
      DO 7 J=1,2
      IF (J.EQ.1) THEN
         CALL BIDIA (A,X,-1,K)
      ELSEIF (J.EQ.2) THEN
         CALL BIDIA (A(K),X(K),1,N-K+1)
      ENDIF
 7    CONTINUE

      END
