      SUBROUTINE CHKOCC (LFLAG)
      INCLUDE 'TYPES.INC'

***   CHKOCC - CHECK FOR OCCURENCE ERROR
*
*     S.SELBERHERR   1979-1986
*
      INCLUDE 'CMSYSX.INC'
      INCLUDE 'CMOS01X.INC'

**    START OF EXECUTABLE CODE
*     ************************
*
*     IF ITEM ALREADY OCCURED, GIVE AN ERROR
      IF (LFLAG) THEN
**       WRITE OCCURENCE ERROR MESSAGE
         CALL ERRMSG (INDKO,'O')
      ELSE
**       SET OCCURENCE FLAG
         LFLAG=.TRUE.
      ENDIF

      END
      SUBROUTINE CLASH
      INCLUDE 'TYPES.INC'

***   CLASH - CHECK FOR SPECIFICATION CLASHES
*
*     S.SELBERHERR   1979-1986
*
      INCLUDE 'CMSYSX.INC'
      INCLUDE 'CMDATX.INC'
      INCLUDE 'CMOS01X.INC'
      CHARACTER*18 FMTCON

**    START OF EXECUTABLE CODE
*     ************************
*
*     ASSEMBLE CONDITIONAL FORMAT
      IF (LPHYCK) THEN
         FMTCON='(''0*ERROR*    '',A)  '
      ELSE
         FMTCON='(''0*WARNING*  '',A)'
      ENDIF

**    CHECK IF ALL *DEVICE* DATA SPECIFIED
      IF (.NOT.(L1ICHA.AND.L1TINS.AND.L1XWGE.AND.L1XLGE)) THEN
         NEROCC=NEROCC+1
         WRITE (NUMOUT,24) 'DEVICE'
      ENDIF

**    CHECK FOR SOI CLASH
      IF ((L1YISU.NEQV.L1YSEM).OR.(L1YISU.NEQV.L1EISU)) THEN
         NEROCC=NEROCC+1
         WRITE (NUMOUT,24)  'DEVICE'
      ENDIF
      IF ((L1YISU.OR.L1YSEM.OR.L1EISU).AND.
     1   (L1UB.OR.L1DUB.OR.L1NUB)) THEN
         NEROCC=NEROCC+1
         WRITE (NUMOUT,27) 'DEVICE','BIAS* OR *STEP'
      ENDIF

**    CHECK IF ALL *BIAS* DATA SPECIFIED
      IF (.NOT.((L1UG.OR.MODEL.EQ.2).AND.L1UD)) THEN
         NEROCC=NEROCC+1
         WRITE (NUMOUT,24) 'BIAS'
      ENDIF

**    CHECK FOR *INTERFACE* DATA CLASH
      IF (.NOT.(L1CISS.EQV.L1XISS)) THEN
         NEROCC=NEROCC+1
         WRITE (NUMOUT,24) 'INTERFACE'
      ENDIF

**    CHECK IF ALL *PROFILE* DATA SPECIFIED
      IF (IFILE.EQ.0) THEN
         IF (.NOT.(L1SUBS.AND.L1TEMP.AND.L1TIME.AND.
     1      (L1SURF.OR.(L1ISDE(1).AND.L1SDAK(1).AND.L1SDDO(1))))) THEN
            NEROCC=NEROCC+1
            WRITE (NUMOUT,24) 'PROFILE'
         ENDIF
         IF (LASYM.OR.L1XOFF) THEN
            IF (.NOT.(L1SURF.OR.(L1ISDE(2).AND.L1SDDO(2).AND.
     1         L1SDAK(2)))) THEN
               NEROCC=NEROCC+1
               WRITE (NUMOUT,24) 'PROFILE'
            ENDIF
         ENDIF
      ENDIF

**    CHECK FOR FLATBAND CLASH
      IF ((L1GATE.OR.L1SNSS).AND.L1UFB) THEN
         NEROCC=NEROCC+1
         WRITE (NUMOUT,25) 'FLATBAND VOLTAGE OVERDETERMINED'
      ENDIF

**    CHECK FOR *STEP* DATA CLASH
      IF (.NOT.((L1DUB.EQV.L1NUB).AND.(L1DUG.EQV.L1NUG).AND.
     1   (L1DUD.EQV.L1NUD))) THEN
         NEROCC=NEROCC+1
         WRITE (NUMOUT,24) 'STEP'
      ENDIF

**    CHECK FOR APPROPRIATE SOURCE-DRAIN VOLTAGE
      IF (ABS(UD-US).LT.0.05) THEN
         NERPHY=NERPHY+1
         WRITE (NUMOUT,25) 'SOURCE-DRAIN VOLTAGE TOO SMALL'
      ENDIF

**    CHECK IF THRESHOLD MODEL AND GATE STEPS ARE GIVEN
      IF (MODEL.EQ.2.AND.L1NUG) THEN
         NEROCC=NEROCC+1
         WRITE (NUMOUT,25)
     1   'NUG-STEPS MUST NOT BE GIVEN WHEN THRESHOLD MODEL IS SELECTED'
      ENDIF

**    CHECK IF CONSISTENT *PROFILE* DATA SPECIFIED
      IF (IFILE.NE.0) THEN
         IF (L1SUBS.OR.L1SURF.OR.L1TEMP.OR.L1TIME
     1   .OR.L1ISDE(1).OR.L1SDAK(1).OR.L1SDDO(1).OR.L1SDTO
     2   .OR.L1ISDE(2).OR.L1SDAK(2).OR.L1SDDO(2)) GOTO 6
         IF (IFILE.EQ.2.AND.(L1LASY.OR.L1FITL.OR.L1XOFF.OR.L1YOFF))
     1   GOTO 6
      ELSE
         IF (L1FITL) GOTO 6
         IF (L1SURF) THEN
            IF (SURF.LT.100.*SUBS) THEN
               NERPHY=NERPHY+1
               WRITE (NUMOUT,FMTCON) 'NON PHYSICAL PREDEPOSITION GIVEN'
            ENDIF
         ELSE
            IF (.NOT.(L1ISDE(1).AND.L1SDAK(1).AND.L1SDDO(1))) GOTO 6
         ENDIF
         IF (.NOT.LASYM.AND.XOFF.LT.0.) GOTO 6
      ENDIF
      GOTO 9

 6    NEROCC=NEROCC+1
      WRITE (NUMOUT,25) 'INCONSISTENT DATA ON PROFILE CARD'

**    CHECK FOR *IMPLANT* DATA CLASHES
 9    IF (L1ICHE(1).OR.L1CHDO(1).OR.L1CHAK(1).OR.L1CHTE.OR.L1CHTI
     1.OR.L1ICHE(2).OR.L1CHDO(2).OR.L1CHAK(2)) THEN
         IF (L1ICHE(1).AND.L1CHDO(1).AND.L1CHAK(1).AND.L1CHTE.AND.
     1   L1CHTI) GOTO 11
 10      WRITE (NUMOUT,24) 'IMPLANT'
         NEROCC=NEROCC+1
         GOTO 12
 11      IF (.NOT.(L1ICHE(2).OR.L1CHDO(2).OR.L1CHAK(2))) GOTO 12
         IF (.NOT.(L1ICHE(2).AND.L1CHDO(2).AND.L1CHAK(2))) GOTO 10
      ENDIF

**    CHECK FOR MODEL CLASH
*
*     CHECK FOR PHYSICAL INCONSISTENCY
 12   LERRB1=.FALSE.
      LERRB2=.FALSE.
      IF (L1UD) THEN
         UD1=UD-US
         UD2=UD1+(NUD-1)*DUD
         LERRB2=ABS(UD1).GT.20..OR.ABS(UD2).GT.20.
      ENDIF
      IF (L1UG) THEN
         UG1=UG-US
         UG2=UG1+(NUG-1)*DUG
         LERRB2=LERRB2.OR.ABS(UG1).GT.20..OR.ABS(UG2).GT.20.
         ENDIF
      IF (L1UB) THEN
         UB1=UB-US
         UB2=UB1+(NUB-1)*DUB
         LERRB1=LERRB1.OR.UB1*ICHANL.GT.0..OR.UB2*ICHANL.GT.0.
         LERRB2=LERRB2.OR.ABS(UB1).GT.20..OR.ABS(UB2).GT.20.
      ENDIF

      IF (LERRB1) THEN
         NERPHY=NERPHY+1
         WRITE (NUMOUT,FMTCON) 'NON PHYSICAL BIASING GIVEN'
      ENDIF

      IF (LERRB2) THEN
         NERPHY=NERPHY+1
         WRITE (NUMOUT,FMTCON) 'BIAS OUT OF ALLOWED RANGE'
      ENDIF

      IF (L1ISDE(1).AND.(ISDELE(1).EQ.1.EQV.ICHANL.EQ.1)) THEN
         NERPHY=NERPHY+1
         WRITE (NUMOUT,FMTCON) 'INCORRECT IMPLANTATION ELEMENT'
      ENDIF

**    WE HOPEFULLY CHECKED FOR ALL POSSIBLE CLASHES
*
*     CHECK IF NEVER CALCULATED QUANTITIES ARE REQUESTED FOR OUTPUT
      IF (MODEL.LT.5) THEN
         IF (LTC) THEN
            WRITE (NUMOUT,26) 'CARRIER TEMPERATURE(S)'
            LTC=.FALSE.
         ENDIF
         IF (MODEL.LT.4) THEN
            IF (LMAJ) THEN
               WRITE (NUMOUT,26) 'MAJORITY QUANTITIES'
               LMAJ=.FALSE.
            ENDIF
            IF (LAVL) THEN
               WRITE (NUMOUT,26) 'AVALANCHE GENERATION RATE'
               LAVL=.FALSE.
            ENDIF
         ENDIF
      ELSE
         IF (LPHI) THEN
            WRITE (NUMOUT,26) 'QUASI-FERMILEVEL(S)'
            LPHI=.FALSE.
         ENDIF
      ENDIF

 24   FORMAT ('0*ERROR*    MISSING DATA ON *',A,'* STATEMENT')
 25   FORMAT ('0*ERROR*    ',A)
 26   FORMAT ('0*WARNING*  ',A,' WILL NEVER BE CALCULATED AND CANNOT',
     1' BE PRINTED...IGNORED')
 27   FORMAT ('0*CAUTION*  CONFLICTING OPTIONS ON *',A,'* AND *',A,
     1' STATEMENT')
      END
      SUBROUTINE ERRMSG (INDERR,ERRCH)
      INCLUDE 'TYPES.INC'

***   ERRMSG - INPUT ERROR MESSAGE PROCESSOR
*
*     S.SELBERHERR   1979-1986
*
      CHARACTER*1 ERRCH
      CHARACTER*20 FMT
      INCLUDE 'CMSYSX.INC'
      INCLUDE 'CMOS01X.INC'

**    START OF EXECUTABLE CODE
*     ************************
*
*     SET PROPER TABULATOR
      IF (ERRCH.NE.'P') THEN
         WRITE (FMT,1) INDERR+10
 1       FORMAT ('('' *ERROR*'',T',I2.2,',A)  ')
         IF (ERRCH.EQ.'S') THEN
            NERSYN=NERSYN+1
         ELSE
            NEROCC=NEROCC+1
         ENDIF
      ELSE
         WRITE (FMT,2) INDERR+10
 2       FORMAT ('('' *CAUTION*'',T',I2.2,',A)')
         NERPHY=NERPHY+1
      ENDIF
**    WRITE OUT ERROR LINE
      WRITE (NUMOUT,FMT) ERRCH

      END
      SUBROUTINE GETLOG (L1LVAL,LVAL)
      INCLUDE 'TYPES.INC'

***   GETLOG - GET LOGICAL AND CHECK OCCURENCE
*
*     S.SELBERHERR   1979-1986
*
      INCLUDE 'CMSYSX.INC'
      INCLUDE 'CMOS01X.INC'

**    START OF EXECUTABLE CODE
*     ************************
*
*     GET LOGICAL VALUE
      IF (BYTE(INDV:INDV).EQ.'Y') THEN
         LVAL=.TRUE.
      ELSE
         LVAL=.FALSE.
         IF (BYTE(INDV:INDV).NE.'N') CALL ERRMSG (INDV,'S')
      ENDIF
**    CHECK FOR OCCURENCE ERROR
      CALL CHKOCC (L1LVAL)

      END
      SUBROUTINE GETREA (L1VAL,VAL)
      INCLUDE 'TYPES.INC'

***   GETREA - GET REAL AND CHECK OCCURENCE AND RANGE
*
*     S.SELBERHERR   1979-1986
*
      PARAMETER (FUTCH=1.E-3)
      INCLUDE 'CMSYSX.INC'
      INCLUDE 'CMOS01X.INC'

**    START OF EXECUTABLE CODE
*     ************************
*
*     GET REAL VALUE
      VAL=REALVA(BYTE(INDV:INDV),ILENV,IERR)
**    CHECK FOR OCCURENCE ERROR
      CALL CHKOCC (L1VAL)
**    CHECK FOR SYNTAX ERROR IN REAL
      IF (IERR.NE.0) THEN
         CALL ERRMSG (INDV,'S')
      ELSE
**       CHECK FOR OUT OF RANGE
         IF (RLOW*(1.-SIGN(FUTCH,RLOW)).LE.VAL.AND.
     1   VAL.LE.RHIGH*(1.+SIGN(FUTCH,RHIGH))) RETURN
**       WRITE OUT-OF-RANGE ERROR MESSAGE
         CALL ERRMSG (INDKO,'P')
      ENDIF

      END
      FUNCTION IPARSE ()
      INCLUDE 'TYPES.INC'

***   IPARSE - GET A PAIR OF PARAMETERS
*
*     S.SELBERHERR   1979-1986
*
      INCLUDE 'CMSYSX.INC'
      INCLUDE 'CMDATX.INC'
      INCLUDE 'CMOS01X.INC'

**    START OF EXECUTABLE CODE
*     ************************
*
*     SKIP BLANKS AND COMMAS
 1    IF (INDK.GT.72) GOTO 4
 2    I=INDK
**    CHECK FOR REST OF LINE BEING COMMENT
 3    IF (BYTE(I:I).EQ.'*') GOTO 4
**    ALLOW MULTIPLE COMMAS AND BLANKS
      IF (INDEX(' ,',BYTE(I:I)).EQ.0) GOTO 5
      I=I+1
      IF (I.LE.72) GOTO 3
**    READ NEXT STATEMENT
 4    READ (NUMINP,'(A)',END=17) BYTE
**    ECHO STATEMENT TO OUTPUT AND REFERENCE FILE
      WRITE (NUMOUT,'(T11,A)') BYTE
      WRITE (NUMREF,'(T12,A)') BYTE
**    SKIP POSSIBLE INTERMIXED COMMENT CARD
      IF (BYTE(1:1).EQ.'*') GOTO 4
**    RETURN, IF NOT CONTINUATION CARD
      IF (BYTE(1:1).NE.'+') GOTO 16
      INDK=2
      GOTO 2

**    EXTRACT KEY TILL ' ' OR '='
 5    J=I
 6    IF (INDEX(' =',BYTE(J:J)).NE.0) GOTO 7
      J=J+1
      IF (J.LE.72) GOTO 6
**    KEY DOES NOT END PRIOR EOL
      CALL ERRMSG (I,'S')
      GOTO 4

**    KEY FOUND
 7    IF (J.NE.I) GOTO 8
**    KEY STARTS WITH AN =
      CALL ERRMSG (J,'S')
      INDK=INDK+2
      GOTO 1

 8    INDKO=I
**    SKIP BLANKS TILL VALUE STARTS
      LEQUCH=.FALSE.
      I=J-1
 9    IF (I.GE.72) GOTO 10
      I=I+1
      IF (BYTE(I:I).EQ.' ') GOTO 9
**    SKIP ONE =
      IF (LEQUCH) GOTO 12
      IF (BYTE(I:I).NE.'=') GOTO 11
      LEQUCH=.TRUE.
      GOTO 9

**    SOME SYNTAX ERROR
 10   CALL ERRMSG (INDKO,'S')
      GOTO 4

**    NO = FOUND
 11   CALL ERRMSG (INDKO,'S')
      INDK=I
      GOTO 2

**    GET END OF VALUE
 12   J=I
**    END OF VALUE INDICATED BY ' ',',','*' OR END OF LINE
 13   IF (INDEX(' ,*',BYTE(J:J)).NE.0) GOTO 14
      J=J+1
      IF (J.LE.72) GOTO 13
**    IS VALUE LONGER THAN 20 CHARS ?
 14   INDK=J
      IF (J-I.LE.20.AND.J-I.NE.0) GOTO 15
      CALL ERRMSG (I,'S')
      GOTO 2

 15   ILENV=J-I
      INDV=I
      IPARSE=0
      RETURN

**    NEW IDENT DETECTED
 16   IPARSE=1
      RETURN

**    END OF INFORMATION ENCOUNTERED
 17   IPARSE=2

      END
      FUNCTION KVBIA ()
      INCLUDE 'TYPES.INC'

***   KVBIA - GET KEYS AND VALUES ON *BIAS* IDENT
*
*     S.SELBERHERR   1979-1986
*
      INCLUDE 'CMDATX.INC'
      INCLUDE 'CMOS01X.INC'
      CHARACTER*2 TWOBYT

**    START OF EXECUTABLE CODE
*     ************************
*
 1    IRET=IPARSE()
      IF (IRET.NE.0) GOTO 2
      TWOBYT=BYTE(INDKO:INDKO+1)
      IF (TWOBYT.EQ.'JC') THEN
**       JC=...
         JCAP=INDEX('AGSDB',BYTE(INDV:INDV))-1
         IF (JCAP.LT.0) CALL ERRMSG(INDV,'S')
         CALL CHKOCC (L1JCAP)
      ELSEIF (TWOBYT.EQ.'UB') THEN
**       UB=...
         UB=REALVA(BYTE(INDV:INDV),ILENV,IERR)
         IF (IERR.NE.0) CALL ERRMSG (INDV,'S')
         CALL CHKOCC (L1UB)
      ELSEIF (TWOBYT.EQ.'UD') THEN
**       UD=...
         UD=REALVA(BYTE(INDV:INDV),ILENV,IERR)
         IF (IERR.NE.0) CALL ERRMSG (INDV,'S')
         CALL CHKOCC (L1UD)
      ELSEIF (TWOBYT.EQ.'UG') THEN
**       UG=...
         UG=REALVA(BYTE(INDV:INDV),ILENV,IERR)
         IF (IERR.NE.0) CALL ERRMSG (INDV,'S')
         CALL CHKOCC (L1UG)
      ELSEIF (TWOBYT.EQ.'US') THEN
**       US=...
         US=REALVA(BYTE(INDV:INDV),ILENV,IERR)
         IF (IERR.NE.0) CALL ERRMSG (INDV,'S')
         CALL CHKOCC (L1US)
      ELSEIF (TWOBYT.EQ.'VI') THEN
**       VI=...
         RLOW=0.
         RHIGH=0.2
         CALL GETREA(L1VI,VI)
         LCAP=.TRUE.
      ELSEIF (TWOBYT.EQ.'VR') THEN
**       VR=...
         RLOW=0.
         RHIGH=0.2
         CALL GETREA(L1VR,VR)
         LCAP=.TRUE.
      ELSE
         CALL ERRMSG (INDKO,'S')
      ENDIF
      GOTO 1

**    NEXT IDENT OR EOF FOUND
 2    KVBIA=IRET

      END
      FUNCTION KVDEV ()
      INCLUDE 'TYPES.INC'

***   KVDEV - GET KEYS AND VALUES ON *DEVICE* IDENT
*
*     S.SELBERHERR   1979-1986
*
      INCLUDE 'CMDATX.INC'
      INCLUDE 'CMOS01X.INC'
      CHARACTER*1 ONEBYT
**    WORK FUNCTION OF N-POLY, P-POLY AND ALUMENUM
      DIMENSION PHIMS(3),EINSS(2)
      DATA PHIMS /-0.55,0.55,-0.59/
      DATA EINSS /3.9,7.2/

**    START OF EXECUTABLE CODE
*     ************************
*
 1    IRET=IPARSE()
      IF (IRET.NE.0) GOTO 2
      ONEBYT=BYTE(INDKO:INDKO)
      IF (ONEBYT.EQ.'B') THEN
**       BULK=...
         RLOW=1.E-4
         RHIGH=2.E-3
         CALL GETREA (L1YISU,YISUBS)
      ELSEIF (ONEBYT.EQ.'C') THEN
**       CHANNEL=...
         ICHANL=INDEX ('NP',BYTE(INDV:INDV))
         IF (ICHANL.EQ.0) CALL ERRMSG (INDV,'S')
         CALL CHKOCC (L1ICHA)
         ICHANL=3-2*ICHANL
      ELSEIF (ONEBYT.EQ.'D') THEN
**       DGAP=...
         RLOW=1.E-6
         RHIGH=1.E-2
         CALL GETREA (L1DGAP,DGAP)
      ELSEIF (ONEBYT.EQ.'F') THEN
**       FILM=...
         RLOW=1.E-5
         RHIGH=5.E-4
         CALL GETREA (L1YSEM,YSEMI)
      ELSEIF (ONEBYT.EQ.'G') THEN
**       GATE=...
         IGATE=INDEX ('NPA',BYTE(INDV:INDV))
         IF (IGATE.EQ.0) THEN
            RLOW=-0.6
            RHIGH=0.6
            CALL GETREA (L1GATE,GATE)
         ELSE
            GATE=PHIMS(IGATE)
            CALL CHKOCC (L1GATE)
         ENDIF
      ELSEIF (ONEBYT.EQ.'I') THEN
**       INS=...
         IEINS=INDEX ('ON',BYTE(INDV:INDV))
         IF (IEINS.EQ.0) THEN
            RLOW=1.
            RHIGH=20.
            CALL GETREA (L1EINS,EINS)
         ELSE
            EINS=EINSS(IEINS)
            CALL CHKOCC (L1EINS)
         ENDIF
      ELSEIF (ONEBYT.EQ.'K') THEN
**       KBULK=...
         RLOW=1.
         RHIGH=20.
         CALL GETREA (L1EISU,EISUBS)
      ELSEIF (ONEBYT.EQ.'L') THEN
**       L=...
         RLOW=2.E-5
         RHIGH=1.E-2
         CALL GETREA (L1XLGE,XLGEO)
      ELSEIF (ONEBYT.EQ.'S') THEN
**       SGAP=...
         RLOW=1.E-6
         RHIGH=1.E-2
         CALL GETREA (L1SGAP,SGAP)
      ELSEIF (ONEBYT.EQ.'T') THEN
**       TINS=...
         RLOW=1.E-6
         RHIGH=1.E-3
         CALL GETREA (L1TINS,TINS)
      ELSEIF (ONEBYT.EQ.'W') THEN
**       W=...
         RLOW=1.E-4
         RHIGH=1.
         CALL GETREA (L1XWGE,XWGEO)
      ELSE
         CALL ERRMSG (INDKO,'S')
      ENDIF
      GOTO 1

**    NEXT IDENT OR EOF FOUND
 2    KVDEV=IRET

      END
      FUNCTION KVEND ()
      INCLUDE 'TYPES.INC'

***   KVEND - GET KEYS AND VALUES ON *END* IDENT
*
*     S.SELBERHERR   1979-1986
*
      INCLUDE 'CMDATX.INC'
      INCLUDE 'CMOS01X.INC'
      CHARACTER*1 ONEBYT

**    START OF EXECUTABLE CODE
*     ************************
*
 1    IRET=IPARSE()
      IF (IRET.NE.0) GOTO 2
      ONEBYT=BYTE(INDKO:INDKO)
      IF (ONEBYT.EQ.'B') THEN
**       BINARY=...
         CALL GETLOG (L1LSAV,LSAVEB)
      ELSEIF (ONEBYT.EQ.'C') THEN
**       CAPERR=...
         RLOW=1.E-5
         RHIGH=5.E-1
         CALL GETREA (L1ERRC,ERRCAP)
      ELSEIF (ONEBYT.EQ.'E') THEN
**       ERROR=...
         RLOW=1.E-5
         RHIGH=5.E-1
         CALL GETREA (L1ERRO,ERROR)
      ELSEIF (ONEBYT.EQ.'T') THEN
**       TCERR=...
         RLOW=1.E-5
         RHIGH=5.E-1
         CALL GETREA (L1ERRT,ERRTC)
      ELSE
         CALL ERRMSG (INDKO,'S')
      ENDIF
      GOTO 1

**    END OF INFORMATION ON INPUT FILE
 2    KVEND=2

      END
      FUNCTION KVIMP (JIMP)
      INCLUDE 'TYPES.INC'

***   KVIMP - GET KEYS AND VALUES ON *IMPLANT* IDENT
*
*     S.SELBERHERR   1979-1986
*
      INCLUDE 'CMDATX.INC'
      INCLUDE 'CMOS01X.INC'
      CHARACTER*2 TWOBYT

**    START OF EXECUTABLE CODE
*     ************************
*
      JIMP=MOD(JIMP,2)+1
 1    IRET=IPARSE()
      IF (IRET.NE.0) GOTO 2
      TWOBYT=BYTE(INDKO:INDKO+1)
      IF (TWOBYT.EQ.'AK') THEN
**       AKEV=...
         RLOW=10.
         RHIGH=300.
         CALL GETREA (L1CHAK(JIMP),CHAKEV(JIMP))
      ELSEIF (TWOBYT.EQ.'DO') THEN
**       DOSE=...
         RLOW=1.E9
         RHIGH=1.E14
         CALL GETREA (L1CHDO(JIMP),CHDOSE(JIMP))
      ELSEIF (TWOBYT.EQ.'EL') THEN
**       ELEM=...
         ICHELE(JIMP)=INDEX ('BPSA',BYTE(INDV:INDV))
         IF (ICHELE(JIMP).EQ.0) CALL ERRMSG (INDV,'S')
         CALL CHKOCC (L1ICHE(JIMP))
      ELSEIF (TWOBYT.EQ.'TE') THEN
**       TEMP=...
         RLOW=800.
         RHIGH=1300.
         CALL GETREA (L1CHTE,CHTEMP)
      ELSEIF (TWOBYT.EQ.'TI') THEN
**       TIME=...
         RLOW=60.
         RHIGH=48.*3600.
         CALL GETREA (L1CHTI,CHTIME)
      ELSE
         CALL ERRMSG (INDKO,'S')
      ENDIF
      GOTO 1

**    NEXT IDENT OR EOF FOUND
 2    KVIMP=IRET

      END
      FUNCTION KVINT ()
      INCLUDE 'TYPES.INC'

***   KVINT - GET KEYS AND VALUES ON *INTERFACE* IDENT
*
*     S.SELBERHERR   1979-1986
*
      INCLUDE 'CMDATX.INC'
      INCLUDE 'CMOS01X.INC'
      CHARACTER*2 TWOBYT

**    START OF EXECUTABLE CODE
*     ************************
*
 1    IRET=IPARSE()
      IF (IRET.NE.0) GOTO 2
      TWOBYT=BYTE(INDKO:INDKO+1)
      IF (TWOBYT.EQ.'CI') THEN
**       CISS=...
         RLOW=-1.E13
         RHIGH=1.E13
         CALL GETREA (L1CISS,CISS)
      ELSEIF (TWOBYT.EQ.'FS') THEN
**       FSS=...
         RLOW=-1.E15
         RHIGH=1.E15
         CALL GETREA (L1SFSS,SFSS)
      ELSEIF (TWOBYT.EQ.'NS') THEN
**       NSS=...
         RLOW=-1.E13
         RHIGH=1.E13
         CALL GETREA (L1SNSS,SNSS)
      ELSEIF (TWOBYT.EQ.'PS') THEN
**       PSS=...
         RLOW=-1.E13
         RHIGH=1.E13
         CALL GETREA (L1RPS,RPS)
      ELSEIF (TWOBYT.EQ.'SI') THEN
**       SISS=...
         RLOW=1.E-6
         RHIGH=1.E-3
         CALL GETREA (L1SISS,SISS)
      ELSEIF (TWOBYT.EQ.'XI') THEN
**       XISS=...
         RLOW=-1.E-2
         RHIGH=1.E-2
         CALL GETREA (L1XISS,XISS)
      ELSE
         CALL ERRMSG (INDKO,'S')
      ENDIF
      GOTO 1

**    NEXT IDENT OR EOF FOUND
 2    KVINT=IRET

      END
      FUNCTION KVMOB ()
      INCLUDE 'TYPES.INC'

***   KVMOB - GET KEYS AND VALUES ON *MOBILITY* IDENT
*
*     S.SELBERHERR  1986
*
      INCLUDE 'CMDATX.INC'
      INCLUDE 'CMOS01X.INC'
      CHARACTER*2 TWOBYT

**    START OF EXECUTABLE CODE
*     ************************
*
 1    IRET=IPARSE()
      IF (IRET.NE.0) GOTO 2
      TWOBYT=BYTE(INDKO:INDKO+1)
      IF (TWOBYT.EQ.'MB') THEN
**       MB=...
         RLOW=0.1
         RHIGH=10.
         CALL GETREA (L1WMB,WMB)
      ELSEIF (TWOBYT.EQ.'MI') THEN
**       MI=...
         RLOW=1.E-4
         RHIGH=1.E6
         CALL GETREA (L1WMI,WMI)
      ELSEIF (TWOBYT.EQ.'ML') THEN
**       ML=...
         RLOW=0.5
         RHIGH=2.
         CALL GETREA (L1WML,WML)
      ELSEIF (TWOBYT.EQ.'MR') THEN
**       MR=...
         RLOW=0.5
         RHIGH=2.
         CALL GETREA (L1WMR,WMR)
      ELSEIF (TWOBYT.EQ.'MS') THEN
**       MS=...
         RLOW=1.E-2
         RHIGH=1.E2
         CALL GETREA (L1WMS,WMS)
      ELSEIF (TWOBYT.EQ.'MT') THEN
**       MT=...
         RLOW=1.E-2
         RHIGH=1.E2
         CALL GETREA (L1WMT,WMT)
      ELSEIF (TWOBYT.EQ.'MV') THEN
**       MV=...
         RLOW=1.E-2
         RHIGH=1.E6
         CALL GETREA (L1WMV,WMV)
      ELSE
         CALL ERRMSG (INDKO,'S')
      ENDIF
      GOTO 1

**    NEXT IDENT OR EOF FOUND
 2    KVMOB=IRET

      END
      FUNCTION KVOPT ()
      INCLUDE 'TYPES.INC'

***   KVOPT - GET KEYS AND VALUES ON *OPTION* IDENT
*
*     S.SELBERHERR   1979-1986
*
      INCLUDE 'CMDATX.INC'
      INCLUDE 'CMOS01X.INC'
      CHARACTER*2 TWOBYT

**    START OF EXECUTABLE CODE
*     ************************
*
 1    IRET=IPARSE()
      IF (IRET.NE.0) GOTO 2
      TWOBYT=BYTE(INDKO:INDKO+1)
      IF (TWOBYT.EQ.'CU') THEN
**       CURRENT=...
         RLOW=-2.E-3
         RHIGH=2.E-3
         CALL GETREA (L1THCU,THCUR)
         THCUR=ABS(THCUR)
         IF (THCUR.LT.0.999E-10) CALL ERRMSG (INDKO,'P')
      ELSEIF (TWOBYT.EQ.'EA') THEN
**       EA=...
         RLOW=1.E-3
         RHIGH=0.1
         CALL GETREA (L1EAME,EAMEV)
      ELSEIF (TWOBYT.EQ.'ED') THEN
**       ED=...
         RLOW=1.E-3
         RHIGH=0.1
         CALL GETREA (L1ECME,ECMED)
      ELSEIF (TWOBYT.EQ.'GR') THEN
**       GRIDFREEZE=...
         CALL GETLOG (L1LGRD,LGRDFZ)
      ELSEIF (TWOBYT.EQ.'IN') THEN
**       INTRINSIC=...
         RLOW=1.E-20
         RHIGH=1.E15
         CALL GETREA (L1CINT,CINTR)
      ELSEIF (TWOBYT.EQ.'MO') THEN
**       MODEL=...
         MODEL=INDEX('1T2AH',BYTE(INDV:INDV))
         IF (MODEL.EQ.0) CALL ERRMSG (INDV,'S')
         CALL CHKOCC (L1MODE)
      ELSEIF (TWOBYT.EQ.'OM') THEN
**       OMEGA=...
         RLOW=1.
         RHIGH=1.E10
         CALL GETREA(L1OMEG,OMEGA)
      ELSEIF (TWOBYT.EQ.'PH') THEN
**       PHYSCK=...
         CALL GETLOG (L1LPHY,LPHYCK)
      ELSEIF (TWOBYT.EQ.'RB') THEN
**       RBULK=...
         RLOW=0.
         RHIGH=1.E5
         CALL GETREA (L1RBUL,RBULK)
      ELSEIF (TWOBYT.EQ.'RD') THEN
**       RDRAIN=...
         RLOW=0.
         RHIGH=100.
         CALL GETREA (L1RDRA,RDRAIN)
      ELSEIF (TWOBYT.EQ.'RS') THEN
**       RSOURCE=...
         RLOW=0.
         RHIGH=100.
         CALL GETREA (L1RSOU,RSOURC)
      ELSEIF (TWOBYT.EQ.'TE') THEN
**       TEMP=...
         RLOW=77.
         RHIGH=450.
         CALL GETREA (L1SIMT,SIMTEM)
      ELSEIF (TWOBYT.EQ.'UF') THEN
**       UFB=...
         RLOW=-3.
         RHIGH=3.
         CALL GETREA (L1UFB,UFB)
      ELSEIF (TWOBYT.EQ.'UN') THEN
**       UN=...
         RLOW=0.
         RHIGH=1.
         CALL GETREA (L1UTP(1),UTP(1))
      ELSEIF (TWOBYT.EQ.'UP') THEN
**       UP=...
         RLOW=0.
         RHIGH=1.
         CALL GETREA (L1UTP(2),UTP(2))
      ELSE
         CALL ERRMSG (INDKO,'S')
      ENDIF
      GOTO 1

**    NEXT IDENT OR EOF FOUND
 2    KVOPT=IRET

      END
      FUNCTION KVOUT ()
      INCLUDE 'TYPES.INC'

***   KVOUT - GET KEYS AND VALUES ON *OUTPUT* IDENT
*
*     S.SELBERHERR   1979-1986
*
      INCLUDE 'CMDATX.INC'
      INCLUDE 'CMOS01X.INC'
      CHARACTER*2 TWOBYT

**    START OF EXECUTABLE CODE
*     ************************
*
 1    IRET=IPARSE()
      IF (IRET.NE.0) GOTO 2
      TWOBYT=BYTE(INDKO:INDKO+1)
      IF (TWOBYT.EQ.'AL') THEN
**       ALL=...
         CALL GETLOG (L1LALL,LALL)
      ELSEIF (TWOBYT.EQ.'AV') THEN
**       AVAL=...
         CALL GETLOG (L1LAVL,LAVL)
      ELSEIF (TWOBYT.EQ.'CC') THEN
**       CC=...
         CALL GETLOG (L1LCC,LCC)
      ELSEIF (TWOBYT.EQ.'DC') THEN
**       DC=...
         CALL GETLOG (L1LDC,LDC)
      ELSEIF (TWOBYT.EQ.'EL') THEN
**       ELAT=...
         CALL GETLOG (L1LEL,LEL)
      ELSEIF (TWOBYT.EQ.'ET') THEN
**       ETRAN=...
         CALL GETLOG (L1LET,LET)
      ELSEIF (TWOBYT.EQ.'IN') THEN
**       INSULATOR=...
         CALL GETLOG (L1LINS,LINS)
      ELSEIF (TWOBYT.EQ.'JL') THEN
**       JLAT=...
         CALL GETLOG (L1LJL,LJL)
      ELSEIF (TWOBYT.EQ.'JT') THEN
**       JTRAN=...
         CALL GETLOG (L1LJT,LJT)
      ELSEIF (TWOBYT.EQ.'MA') THEN
**       MAJ=...
         CALL GETLOG (L1LMAJ,LMAJ)
      ELSEIF (TWOBYT.EQ.'MI') THEN
**       MIN=...
         CALL GETLOG (L1LMIN,LMIN)
      ELSEIF (TWOBYT.EQ.'MO') THEN
**       MOB=...
         CALL GETLOG (L1LMOB,LMOB)
      ELSEIF (TWOBYT.EQ.'NO') THEN
**       NONE=...
         CALL GETLOG (L1LNON,LNON)
      ELSEIF (TWOBYT.EQ.'OX') THEN
**       OXIDE=...
         CALL GETLOG (L1LINS,LINS)
      ELSEIF (TWOBYT.EQ.'PH') THEN
**       PHI=...
         CALL GETLOG (L1LPHI,LPHI)
      ELSEIF (TWOBYT.EQ.'PS') THEN
**       PSI=...
         CALL GETLOG (L1LPSI,LPSI)
      ELSEIF (TWOBYT.EQ.'RH') THEN
**       RHO=...
         CALL GETLOG (L1LRHO,LRHO)
      ELSEIF (TWOBYT.EQ.'TC') THEN
**       TC=...
         CALL GETLOG (L1LTC,LTC)
      ELSE
        CALL ERRMSG (INDKO,'S')
      ENDIF
      GOTO 1

**    NEXT IDENT OR EOF FOUND
 2    KVOUT=IRET

      END
      FUNCTION KVPRO (JPRO)
      INCLUDE 'TYPES.INC'

***   KVPRO - GET KEYS AND VALUES ON *PROFILE* IDENT
*
*     S.SELBERHERR   1979-1986
*
      INCLUDE 'CMDATX.INC'
      INCLUDE 'CMOS01X.INC'
      CHARACTER*2 TWOBYT

**    START OF EXECUTABLE CODE
*     ************************
*
      JPRO=MOD(JPRO,2)+1
 1    IRET=IPARSE()
      IF (IRET.NE.0) GOTO 2
      TWOBYT=BYTE(INDKO:INDKO+1)
      IF (TWOBYT.EQ.'AK') THEN
**       AKEV=...
         RLOW=10.
         RHIGH=300.
         CALL GETREA (L1SDAK(JPRO),SDAKEV(JPRO))
      ELSEIF (TWOBYT.EQ.'AS') THEN
**       ASYM=...
         CALL GETLOG (L1LASY,LASYM)
         IPROF=IPROF+2
      ELSEIF (TWOBYT.EQ.'DO') THEN
**       DOSE=...
         RLOW=1.E10
         RHIGH=1.E17
         CALL GETREA (L1SDDO(JPRO),SDDOSE(JPRO))
      ELSEIF (TWOBYT.EQ.'EL') THEN
**       ELEM=...
         ISDELE(JPRO)=INDEX ('BPSA',BYTE(INDV:INDV))
         IF (ISDELE(JPRO).EQ.0) CALL ERRMSG (INDV,'S')
         CALL CHKOCC (L1ISDE(JPRO))
      ELSEIF (TWOBYT.EQ.'FI') THEN
**       FILE=...
         IFILE=INDEX('N0Y12',BYTE(INDV:INDV))
         IF (IFILE.EQ.0) CALL ERRMSG (INDV,'S')
         IFILE=(IFILE-1)/2
         CALL CHKOCC (L1IFIL)
      ELSEIF (TWOBYT.EQ.'LF') THEN
**       LFIT=...
         RLOW=0.1
         RHIGH=2.
         CALL GETREA (L1FITL,FITL)
      ELSEIF (TWOBYT.EQ.'NB') THEN
**       NB=...
         RLOW=5.E13
         RHIGH=5.E17
         CALL GETREA (L1SUBS,SUBS)
      ELSEIF (TWOBYT.EQ.'NS') THEN
**       NS=...
         RLOW=1.E15
         RHIGH=1.E22
         CALL GETREA (L1SURF,SURF)
      ELSEIF (TWOBYT.EQ.'TE') THEN
**       TEMP=...
         RLOW=800.
         RHIGH=1300.
         CALL GETREA (L1TEMP,TEMP)
      ELSEIF (TWOBYT.EQ.'TI') THEN
**       TIME=...
         RLOW=60.
         RHIGH=48.*3600.
         CALL GETREA (L1TIME,TIME)
      ELSEIF (TWOBYT.EQ.'TO') THEN
**       TOX=...
         RLOW=0.
         RHIGH=1.E-3
         CALL GETREA (L1SDTO,SDTOX)
      ELSEIF (TWOBYT.EQ.'XO') THEN
**       XOFF=...
         RLOW=-2.E-4
         RHIGH=2.E-4
         CALL GETREA (L1XOFF,XOFF)
         IPROF=IPROF+4
      ELSEIF (TWOBYT.EQ.'YO') THEN
**       YOFF=...
         RLOW=0.
         RHIGH=1.E-4
         CALL GETREA (L1YOFF,YOFF)
      ELSE
         CALL ERRMSG (INDKO,'S')
      ENDIF
      GOTO 1

**    NEXT IDENT OR EOF FOUND
 2    KVPRO=IRET

      END
      FUNCTION KVREC ()
      INCLUDE 'TYPES.INC'

***   KVREC - GET KEYS AND VALUES ON *RECOMB* IDENT
*
*     S.SELBERHERR  1986
*
      INCLUDE 'CMDATX.INC'
      INCLUDE 'CMOS01X.INC'

**    START OF EXECUTABLE CODE
*     ************************
*
 1    IRET=IPARSE()
      IF (IRET.NE.0) GOTO 9
      I=INDEX('NP',BYTE(INDKO+1:INDKO+1))
      J=INDEX('ABCSTV',BYTE(INDKO:INDKO))
      IF (I.EQ.0.OR.J.EQ.0) GOTO 8
      GOTO (2,3,4,5,6,7) J

**    AN=... OR AP=...
 2    RLOW=0.
      RHIGH=1.E9
      CALL GETREA (L1ALPH(I),ALPHA(I))
      GOTO 1

**    BN=... OR BP=...
 3    RLOW=5.E5
      RHIGH=1.E7
      CALL GETREA (L1BETA(I),BETA(I))
      GOTO 1

**    CN=... OR CP=...
 4    RLOW=0.
      RHIGH=1.E-28
      CALL GETREA (L1AUGE(I),AUGER(I))
      GOTO 1

**    SN=... OR SP=...
 5    RLOW=1.
      RHIGH=1.E7
      CALL GETREA (L1SRV(I),SRV(I))
      GOTO 1

**    TN=... OR TP=...
 6    RLOW=1.E-9
      RHIGH=1.E6
      CALL GETREA (L1TAU(I),TAU(I))
      GOTO 1

**    VN=... OR VP=...
 7    RLOW=1.
      RHIGH=1.E7
      CALL GETREA (L1VRV(I),VRV(I))
      GOTO 1

 8    CALL ERRMSG (INDKO,'S')
      GOTO 1

**    NEXT IDENT OR EOF FOUND
 9    KVREC=IRET

      END
      FUNCTION KVSTE ()
      INCLUDE 'TYPES.INC'

***   KVSTE - GET KEYS AND VALUES ON *STEP* IDENT
*
*     S.SELBERHERR   1979-1986
*
      INCLUDE 'CMDATX.INC'
      INCLUDE 'CMOS01X.INC'
      CHARACTER*2 TWOBYT

**    START OF EXECUTABLE CODE
*     ************************
*
 1    IRET=IPARSE()
      IF (IRET.NE.0) GOTO 2
      TWOBYT=BYTE(INDKO:INDKO+1)
      IF (TWOBYT.EQ.'DB') THEN
**       DB=...
         RLOW=-5.
         RHIGH=5.
         CALL GETREA (L1DUB,DUB)
         IF (ABS(DUB).LT.0.00999) CALL ERRMSG (INDKO,'P')
      ELSEIF (TWOBYT.EQ.'DD') THEN
**       DD=...
         RLOW=-5.
         RHIGH=5.
         CALL GETREA (L1DUD,DUD)
         IF (ABS(DUD).LT.0.00999) CALL ERRMSG (INDKO,'P')
      ELSEIF (TWOBYT.EQ.'DG') THEN
**       DG=...
         RLOW=-5.
         RHIGH=5.
         CALL GETREA (L1DUG,DUG)
         IF (ABS(DUG).LT.0.00999) CALL ERRMSG (INDKO,'P')
      ELSEIF (TWOBYT.EQ.'NB') THEN
**       NB=...
         RLOW=1.
         RHIGH=20.
         CALL GETREA (L1NUB,H)
         NUB=INT(H)+1
      ELSEIF (TWOBYT.EQ.'ND') THEN
**       ND=...
         RLOW=1.
         RHIGH=20.
         CALL GETREA (L1NUD,H)
         NUD=INT(H)+1
      ELSEIF (TWOBYT.EQ.'NG') THEN
**       NG=...
         RLOW=1.
         RHIGH=20.
         CALL GETREA (L1NUG,H)
         NUG=INT(H)+1
      ELSE
         CALL ERRMSG (INDKO,'S')
      ENDIF
      GOTO 1

**    NEXT IDENT OR EOF FOUND
 2    KVSTE=IRET

      END
      FUNCTION REALVA (BYTE,MAXIND,IERR)
      INCLUDE 'TYPES.INC'

***   REALVA - STRING TO REAL CONVERSION
*
*     S.SELBERHERR   1979-1986
*
C     CHARACTER*(MAXIND) BYTE
      CHARACTER*20 BYTE

**    START OF EXECUTABLE CODE
*     ************************
*
      IERR=0
      RMSIGN=1.
      IESIGN=1
      IEXPO=0
      RMANT=0.
      J=1

**    CHECK FOR MANTISSA SIGN
      IF (BYTE(J:J).EQ.'+') GOTO 1
      IF (BYTE(J:J).NE.'-') GOTO 2
      RMSIGN=-RMSIGN

 1    J=J+1
      IF (J.GT.MAXIND) GOTO 9
 2    I=INDEX('0123456789',BYTE(J:J))
      IF (I.EQ.0) GOTO 3
      RMANT=RMANT*10.+(I-1)
      GOTO 1

**    CHECK FOR FRACTION PART
 3    IF (BYTE(J:J).NE.'.') GOTO 5
      DIV=1.
 4    J=J+1
      IF (J.GT.MAXIND) GOTO 9
      DIV=DIV*0.1
      I=INDEX('0123456789',BYTE(J:J))
      IF (I.EQ.0) GOTO 5
      RMANT=RMANT+(I-1)*DIV
      GOTO 4

**    CHECK FOR EXPONENT
 5    IF (BYTE(J:J).NE.'E') GOTO 8
      J=J+1
      IF (J.GT.MAXIND) GOTO 9
**    CHECK FOR EXPONENT SIGN
      IF (BYTE(J:J).EQ.'+') GOTO 6
      IF (BYTE(J:J).NE.'-') GOTO 7
      IESIGN=-IESIGN
 6    J=J+1
      IF (J.GT.MAXIND) GOTO 9
 7    I=INDEX('0123456789',BYTE(J:J))
      IF (I.EQ.0) GOTO 8
      IEXPO=IEXPO*10+I-1
      GOTO 6

**    CHECK FOR LEGAL DELIMITERS
 8    IF (INDEX(' ,',BYTE(J:J)).NE.0) GOTO 9
      IF (BYTE(J:J).NE.'*') GOTO 10

 9    REALVA=(RMANT*RMSIGN)*10.**(IEXPO*IESIGN)
      RETURN

**    ILLEGAL CHARACTER DETECTED
 10   REALVA=0.
      IERR=1

      END
      SUBROUTINE SUB01
      INCLUDE 'TYPES.INC'

***   SUB01 - DIRECTIVES PROCESSOR
*
*     S.SELBERHERR   1979-1986
*
      INCLUDE 'CMSYSX.INC'
      INCLUDE 'CMDATX.INC'
      INCLUDE 'CMOS01X.INC'
      CHARACTER*2 TWOBYT

      DATA JIMP,JPRO /0,0/

**    START OF EXECUTABLE CODE
*     ************************
*
*     READ THE TITLE LINE
      READ (NUMINP,'(A)',END=1) TITLE
      GOTO 2

**    ABORT JOB IF INPUT FILE EMPTY
 1    CALL ABTMOS (3)

**    GET TODAYS DATE AND CURRENT TIME
 2    CALL ZZZDAT (DATTIM)
**    WRITE FIRST HEADING
      CALL WRTHED
**    WRITE HEADING OF REFERENCE FILE
      WRITE (NUMREF,3) DATTIM,TITLE
 3    FORMAT('1',T12,'*MINIMOS* REFERENCE FILE',T41,A//T12,A)

**    READ NEXT STATEMENT
 4    READ (NUMINP,'(A)',END=23) BYTE
**    ECHO STATEMENT TO OUTPUT AND REFERENCE FILE
      WRITE (NUMOUT,'(T11,A)') BYTE
      WRITE (NUMREF,'(T12,A)') BYTE

**    MAIN LOOP
*
*     SKIP LEADING BLANKS AND FIND KEYWORD
 5    I=0
 6    I=I+1
      IF (BYTE(I:I).NE.' ') GOTO 7
      IF (I.LT.72) GOTO 6
**    COMPLETE BLANK LINE, SKIP IT
      GOTO 4

**    GET DELIMITER
 7    J=I
 8    IF (INDEX(' ,*',BYTE(J:J)).NE.0) GOTO 9
      J=J+1
      IF (J.LE.72) GOTO 8
**    EXTRACT KEYWORD
 9    IF (J.NE.I) GOTO 10
      IF (BYTE(J:J).EQ.'*') GOTO 4
      CALL ERRMSG (I,'S')
      GOTO 4

**    SAVE START OF KEYWORD
 10   INDV=I
**    SAVE START OF DIRECTIVE IDENTIFIER
      INDKO=I
**    A ONE LETTER IDENT IS NOT EXISTING
      IF (BYTE(INDKO+1:INDKO+1).EQ.' ') GOTO 11
**    SAVE DIRECTIVE IDENTIFIER
      TWOBYT=BYTE(INDKO:INDKO+1)
**    SAVE POSSIBLE START OF FIRST KEY
      INDK=J


**    JUMP TO IDENT PROCESSOR
      GOTO (12,13,14,15,16,17,18,19,20,21,22)
     1(INDEX('BI DE EN IM IN MO OP OU PR RE ST',TWOBYT)+2)/3

**    UNKNOWN IDENT GIVEN
 11   CALL ERRMSG (INDKO,'S')
      GOTO 4

**    BIAS,...
 12   GOTO (5,23) KVBIA ()

**    DEVICE,...
 13   GOTO (5,23) KVDEV ()

**    END,...
 14   GOTO (5,23) KVEND ()

**    IMPLANT,...
 15   GOTO (5,23) KVIMP (JIMP)

**    INTERFACE,...
 16   GOTO (5,23) KVINT ()

**    MOBILITY,...
 17   GOTO (5,23) KVMOB ()

**    OPTION,...
 18   GOTO (5,23) KVOPT ()

**    OUTPUT,...
 19   GOTO (5,23) KVOUT ()

**    PROFILE,...
 20   GOTO (5,23) KVPRO (JPRO)

**    RECOMBINATION,...
 21   GOTO (5,23) KVREC ()

**    STEP,...
 22   GOTO (5,23) KVSTE ()

**    ADJUST OUTPUT FLAGS
 23   IF (LNON) THEN
         LAVL=.FALSE.
         LCC=.FALSE.
         LDC=.FALSE.
         LEL=.FALSE.
         LET=.FALSE.
         LJL=.FALSE.
         LJT=.FALSE.
         LMOB=.FALSE.
         LPHI=.FALSE.
         LPSI=.FALSE.
         LRHO=.FALSE.
         LTC=.FALSE.
      ELSEIF (LALL) THEN
         LCC=.TRUE.
         LDC=.TRUE.
         LEL=.TRUE.
         LET=.TRUE.
         LINS=.TRUE.
         LJL=.TRUE.
         LJT=.TRUE.
         LMIN=.TRUE.
         LMOB=.TRUE.
         LPHI=.TRUE.
         LPSI=.TRUE.
         LRHO=.TRUE.
         IF (MODEL.GE.4) THEN
            LAVL=.TRUE.
            LMAJ=.TRUE.
            IF (MODEL.EQ.5) THEN
               LPHI=.FALSE.
               LTC=.TRUE.
            ELSE
               LTC=.FALSE.
            ENDIF
         ELSE
            LAVL=.FALSE.
            LMAJ=.FALSE.
         ENDIF
      ENDIF

**    CHECK FOR SPECIFICATION CLASHES AND COMPLETE DATA
      CALL CLASH

**    UPDATE PROFILE INDICATOR APPROPRIATELY
      IF (ISDELE(MIN(IPROF+1,2)).NE.0) IPROF=IPROF+1

**    IF NO ERROR(S) WE ARE FINISHED WITH THE INPUT
      IF (NERSYN+NEROCC.NE.0.OR.(NERPHY.NE.0.AND.LPHYCK)) CALL ABTMOS(1)

      END
