      SUBROUTINE BINAER (PSI,CMIN,CMAJ,CDON,CACC,HLP1,HLP2)
      INCLUDE 'TYPES.INC'

***   BINAER - SAVE RESULTS ON BINARY FILE
*
*     A.SCHUETZ      1980-1983
*     S.SELBERHERR   1979-1986
*
      INCLUDE 'CMSYSX.INC'
      INCLUDE 'CMDATX.INC'
      INCLUDE 'CMOS02X.INC'
      INCLUDE 'CMEMX.INC'
      DIMENSION PSI(NXYTOT),CMIN(NXY),CMAJ(NXY),CDON(NXY),CACC(NXY),
     1HLP1(NXYTOT),HLP2(NXYTOT)
      CHARACTER*1 CHCOD(2)

      DATA CHCOD /'N','P'/

**    START OF EXECUTABLE CODE
*     ************************
*
      UTCH=UT*ICHANL
      CURNOR=Q*CNOR*XYNOR*ICHANL
      DIFNOR=XYNOR**2/UT

**    FIRST WRITE TITLE ONTO BINARY FILE
      WRITE (NUMBIN) TITLE

**    NOW WRITE CHANNEL-TYPE, FLATBAND VOLTAGE, OXIDE THICKNESS,
*     CHANNEL-WIDTH, AND CHANNEL-LENGTH
      HLP1(1)=UFB*UTCH-(Q/8.854187818E-14)*SNSS*CNOR*XYNOR**2*TINS/EINS
      HLP1(2)=TINS*XYNOR
      HLP1(3)=XLGEO*XYNOR
      HLP1(4)=XWGEO*XYNOR
      J=(3-ICHANL)/2
      WRITE (NUMBIN) CHCOD(J),(HLP1(I),I=1,4)

**    WRITE BIAS CONDITION
      HLP1(1)=US*UTCH
      HLP1(2)=(UG+US)*UTCH
      HLP1(3)=(UD+US)*UTCH
      HLP1(4)=(UB+US)*UTCH
      HLP1(5)=(FLUXD(1)-FLUXD(2))*FLUNOR
      HLP1(6)=-(FLUXB(1)-FLUXB(2)+FLUXD(1)-FLUXD(2))*FLUNOR
      HLP1(7)=(FLUXB(1)-FLUXB(2))*FLUNOR
      WRITE (NUMBIN) (HLP1(I),I=1,7)

**    WRITE COUPLE OF PHYSICAL CONSTANTS
      WRITE (NUMBIN) XYNOR/SQRT(CINTR),UT,CINTR*CNOR

**    WRITE GRID SIZE COUNTERS
      WRITE (NUMBIN) NX,NT,NY,NYOX-1,NYTOT,NXS+1,NXD-1

**    WRITE LATERAL SPACING
      WRITE (NUMBIN) (X(I)*XYNOR,I=1,NX)

**    WRITE TRANSVERSAL SPACING
      WRITE (NUMBIN) (Y(I)*XYNOR,I=1,NYTOT)

**    SAVE DOPING CONCENTRATION
      WRITE (NUMBIN) ((CDON(I)-CACC(I))*CNOR,I=1,NXY)

**    SAVE POTENTIAL DISTRIBUTION
      WRITE (NUMBIN) ((PSI(I)+US)*UTCH,I=1,NXYTOT)

**    SAVE MINORITY CARRIER CONCENTRATION
      WRITE (NUMBIN) (CMIN(I)*CNOR,I=1,NXT)

**    SAVE MINORITY MOBILTY
      CALL SLTGET (HLP1,IDIF(1),NXT)
      IF (MODEL.EQ.5) THEN
         CALL SLTGET (HLP2,ITC(1),NXT)
         DO 7701 L=1,NXT
 7701    HLP1(L)=HLP1(L)/HLP2(L)
      ENDIF
      WRITE (NUMBIN) (HLP1(I)*DIFNOR,I=1,NXT)
      IF (IDIF(3).NE.JSLPRE) THEN
         CALL SLTGET (HLP1,IDIF(3),NXT)
         IF (MODEL.EQ.5) THEN
            DO 7702 L=1,NXT
 7702       HLP1(L)=HLP1(L)/HLP2(L)
         ENDIF
      ENDIF
      WRITE (NUMBIN) (HLP1(I)*DIFNOR,I=1,NXT)

**    SAVE MINORITY CURRENT DENSITY
      CALL SLTGET (HLP2,IJD(1),NXT-1)
      CALL INTERX (HLP1,HLP2,NX,NT,0)
      WRITE (NUMBIN) (HLP1(I)*CURNOR,I=1,NXT)
      CALL SLTGET (HLP2,IJD(3),NXTMX)
         IF (LBOTI.OR.MODEL.LE.3) THEN
            MODI=0
         ELSE
            MODI=2
         ENDIF
      CALL INTERY (HLP1,HLP2,NX,NT,MODI)
      WRITE (NUMBIN) (HLP1(I)*CURNOR,I=1,NXT)

      IF (MODEL.GE.4) THEN

**       SAVE MAJORITY CARRIER CONCENTRATION
         WRITE (NUMBIN) (CMAJ(I)*CNOR,I=1,NXT)

**       SAVE MAJORITY MOBILITY
         CALL SLTGET (HLP1,IDIF(2),NXT)
         IF (MODEL.EQ.5) THEN
            CALL SLTGET (HLP2,ITC(2),NXT)
            DO 7703 L=1,NXT
 7703       HLP1(L)=HLP1(L)/HLP2(L)
         ENDIF
         WRITE (NUMBIN) (HLP1(I)*DIFNOR,I=1,NXT)
         IF (IDIF(4).NE.JSLPRE) THEN
            CALL SLTGET (HLP1,IDIF(4),NXT)
            IF (MODEL.EQ.5) THEN
               DO 7704 L=1,NXT
 7704          HLP1(L)=HLP1(L)/HLP2(L)
            ENDIF
         ENDIF
         WRITE (NUMBIN) (HLP1(I)*DIFNOR,I=1,NXT)

**       SAVE MAJORITY CURRENT DENSITY
         CALL SLTGET (HLP2,IJD(2),NXT-1)
         CALL INTERX (HLP1,HLP2,NX,NT,0)
         WRITE (NUMBIN) (-HLP1(I)*CURNOR,I=1,NXT)
         CALL SLTGET (HLP2,IJD(4),NXTMX)
         CALL INTERY (HLP1,HLP2,NX,NT,MODI)
         WRITE (NUMBIN) (-HLP1(I)*CURNOR,I=1,NXT)

**       SAVE AVALANCHE GENERATION RATE
         CALL SLTGET (HLP1,IGEN,NXT)
         WRITE (NUMBIN) (HLP1(I)*CNOR,I=1,NXT)

         IF (MODEL.GE.5) THEN

**          SAVE MINORITY CARRIER TEMPERATURE
            CALL SLTGET (HLP1,ITC(1),NXT)
            WRITE (NUMBIN) (HLP1(I)*SIMTEM,I=1,NXT)

**          SAVE MAJORITY CARRIER TEMPERATURE
            CALL SLTGET (HLP1,ITC(2),NXT)
            WRITE (NUMBIN) (HLP1(I)*SIMTEM,I=1,NXT)
         ENDIF
      ENDIF

**    MARK END OF FILE
      ENDFILE NUMBIN

      END
      SUBROUTINE PRARAY (NN,MM,ARRAY,HEAD,DIM,RENOR,N,M,XX,YY,IFMT)
      INCLUDE 'TYPES.INC'

***   PRARAY - PRINT AN ARRAY
*
*     S.SELBERHERR   1979-1986
*
*     ISTRIP - NUMBER OF COLUMNS/PAGE OF ARRAY OUTPUT
      PARAMETER (ISTRIP=12)
      INCLUDE 'CMSYSX.INC'
      DIMENSION ARRAY(NN,MM),XX(NN),YY(MM)
      CHARACTER*(*) HEAD,DIM
      CHARACTER*22 FMTS(3),FMT

      DATA FMTS(1) /'(1X,F8.4,1X,1P24E10.2)'/
      DATA FMTS(2) /'(1X,F8.4,1X,24F10.3)  '/
      DATA FMTS(3) /'(1X,F8.4,1X,24F10.0)  '/

**    START OF EXECUTABLE CODE
*     ************************
*
*     SET REQUESTED FORMAT
      FMT=FMTS(IFMT)
**    LOOP OVER SLICES
      DO 1 K=1,(N+ISTRIP-1)/ISTRIP
      N1=(K-1)*ISTRIP+1
      N2=MIN(K*ISTRIP,N)
**    PRINT HEADER
      CALL WRTHED
      WRITE (NUMOUT,'(10X,A,T35,A,T51,''PART:'',I2)') HEAD,DIM,K
      WRITE (NUMOUT,'(/10X,24F10.4)') (XX(I),I=N1,N2)
      WRITE (NUMOUT,'(1X)')
**    PRINT ARRAY
      DO 1 J=1,M
 1    WRITE (NUMOUT,FMT) YY(J),(ARRAY(I,J)*RENOR,I=N1,N2)

      END
      SUBROUTINE SUB02F
      INCLUDE 'TYPES.INC'

***   SUB02F - *OUTPUT* PROCESSOR
*
*     A.SCHUETZ      1980-1983
*     S.SELBERHERR   1979-1986
*
      INCLUDE 'CMSYSX.INC'
      INCLUDE 'CMDATX.INC'
      INCLUDE 'CMOS02X.INC'
      INCLUDE 'CMEMX.INC'
      INCLUDE 'CPADBLK.INC'
      CHARACTER*23 TQU(2),TCR(2),TCL(2),TCT(2),TML(2),TMT(2),TUT(2)

      DATA TQU /'ELECTRON FERMILEVEL    ','HOLE FERMILEVEL        '/
      DATA TCR /'ELECTRON CONCENTRATION ','HOLE CONCENTRATION     '/
      DATA TCL /'LATER.ELECTRON CURRENT ','LATER. HOLE CURRENT    '/
      DATA TCT /'TRANS.ELECTRON CURRENT ','TRANS. HOLE CURRENT    '/
      DATA TML /'LATER.ELECTRON MOBILITY','LATER. HOLE MOBILITY   '/
      DATA TMT /'TRANS.ELECTRON MOBILITY','TRANS. HOLE MOBILITY   '/
      DATA TUT /'ELECTRON TEMPERATURE   ','HOLE TEMPERATURE       '/

**    START OF EXECUTABLE CODE
*     ************************


**    LOAD DISTRIBUTIONS
      IF (IPSI  .NE.JSLPRE) CALL SLTGET (PAD(JP(1)),IPSI  ,NXYTOT)
      IF (ICC(1).NE.JSLPRE) CALL SLTGET (PAD(JP(2)),ICC(1),NXY)
      IF (ICC(2).NE.JSLPRE) CALL SLTGET (PAD(JP(3)),ICC(2),NXY)
      IF (ICDON .NE.JSLPRE) CALL SLTGET (PAD(JP(4)),ICDON ,NXY)
      IF (ICACC .NE.JSLPRE) CALL SLTGET (PAD(JP(5)),ICACC ,NXY)

**    SETUP SOME FREQUENTLY USED CONSTANTS
      INDMAJ=(ICHANL+3)/2
      INDMIN=3-INDMAJ
      UTCH=UT*ICHANL
      CNORCH=CNOR*ICHANL
      DIFNOR=XYNOR**2/UT

**    INSULATOR CAPACITANCE
      CINS=8.854187818E-14*EINS/(TINS*XYNOR)

**    ALLOCATE SPACE FOR MESH VARIABLES
      IX1=JP(10)
      IX2=IX1+NX
      IY1=IX2+NX-1
      IY2=IY1+NYTOT
      IY3=IY1+NYOX-1
      IY4=IY2+NYOX-1

**    COMPUTE MESH VARIABLES
      RELNOR=1.E4*XYNOR
      DO 7701 L=1,NX
 7701 PAD(L+IX1-1)=RELNOR*X(L)
      DO 7702 L=1,NYTOT
 7702 PAD(L+IY1-1)=RELNOR*Y(L)
      RELNOR=RELNOR/2
      DO 7703 L=1,NX-1
 7703 PAD(L+IX2-1)=RELNOR*(X(L)+X(L+1))
      DO 7704 L=1,NYTOT-1
 7704 PAD(L+IY2-1)=RELNOR*(Y(L)+Y(L+1))

**    PRINT PAGE WITH GENERAL INFORMATION
      CALL WRTHED

**    BIAS CONDITIONS
      WRITE (NUMOUT,101) 'SOURCE VOLTAGE',US*UTCH,'(V)'
      IF (MODEL.NE.2) WRITE (NUMOUT,101) 'GATE VOLTAGE',(UG+US)*UTCH,
     1'(V)'
      WRITE (NUMOUT,101) 'DRAIN VOLTAGE',(UD+US)*UTCH,'(V)'
      IF (.NOT.LBOTI) WRITE (NUMOUT,101) 'BULK VOLTAGE',(UB+US)*UTCH,
     1'(V)'

**    A FEW INTERESTING VOLTAGES
      WRITE (NUMOUT,'(/)')
      IF (IFAIL.NE.1) THEN
         WRITE (NUMOUT,101) 'FERMI VOLTAGE',UF*UTCH*1000,'(MV)'
         IF (.NOT.LBOTI) WRITE (NUMOUT,101) 'FLATBAND VOLTAGE',
     1   (UFB*UTCH-Q*SNSS*CNOR*XYNOR/CINS)*1000,'(MV)'
      ENDIF
      WRITE (NUMOUT,101) 'WORK FUNCTION',GATE*1000,'(MV)'
      WRITE (NUMOUT,101) 'THERMAL VOLTAGE',UT*1000,'(MV)'

**    A FEW MORE INTERESTING PARAMETERS
      WRITE (NUMOUT,'(/)')
      IF (IFAIL.NE.1) THEN
         WRITE (NUMOUT,102) 'OXIDE CAPACITANCE',CINS,'(F/CM**2)'
         WRITE (NUMOUT,103) 'JUNCTION DEPTH',YJS*XYNOR*1.E4,'(MICRON)'
         WRITE (NUMOUT,103) 'SUBDIFFUSION',XJS*XYNOR*1.E4,'(MICRON)'
      ENDIF
      WRITE (NUMOUT,102) 'DEBEYE LENGTH',XYNOR/SQRT(CINTR)*1.E4,
     1'(MICRON)'
      WRITE (NUMOUT,102) 'INTRINSIC NUMBER',CINTR*CNOR,'(CM**-3)'

      IF (ZMOB(1).GT.0.OR.ZMOB(2).GT.0) THEN
         WRITE (NUMOUT,'(/20X,''MAXIMUM MOBILITY'')')
         IF (ZMOB(INDMIN).GT.0) WRITE (NUMOUT,102)
     1   'FOR ELECTRONS',ZMOB(INDMIN),'(CM**2/V/S)'
         IF (ZMOB(INDMAJ).GT.0) WRITE (NUMOUT,102)
     1   'FOR HOLES',ZMOB(INDMAJ),'(CM**2/V/S)'
      ENDIF

      IF (VSAT(1).GT.0.OR.VSAT(2).GT.0) THEN
         WRITE (NUMOUT,'(/20X,''MAXIMUM DRIFT VELOCITY'')')
         IF (VSAT(INDMIN).GT.0) WRITE (NUMOUT,102)
     1   'FOR ELECTRONS',VSAT(INDMIN),'(CM/S)'
         IF (VSAT(INDMAJ).GT.0) WRITE (NUMOUT,102)
     1   'FOR HOLES',VSAT(INDMAJ),'(CM/S)'
      ENDIF

      IF (TAUEN(1).GT.0.OR.TAUEN(2).GT.0) THEN
         WRITE (NUMOUT,'(/20X,''MAXIMUM ENERGY RELAXATION TIME'')')
         IF (TAUEN(INDMIN).GT.0) WRITE (NUMOUT,102)
     1   'FOR ELECTRONS',TAUEN(INDMIN),'(S)'
         IF (TAUEN(INDMAJ).GT.0) WRITE (NUMOUT,102)
     1   'FOR HOLES',TAUEN(INDMAJ),'(S)'
      ENDIF

**    NOW PRINT INTEGRAL RESULTS
      IF (IFAIL.NE.1) THEN
         IF (MODEL.EQ.2) THEN
**          THRESHOLD VOLTAGE
            WRITE (NUMOUT,'(/)')
            WRITE (NUMOUT,101) 'THRESHOLD VOLTAGE',(UG+US)*UTCH,'(V)'
         ENDIF
**       TERMINAL CURRENTS
         WRITE (NUMOUT,'(/)')
         WRITE (NUMOUT,102) 'DRAIN CURRENT',FLUX1D*FLUNOR,
     1   '(A) MODEL=1-D'
         IF (IMODEL.GE.3) THEN
            WRITE (NUMOUT,'(/)')
            WRITE (NUMOUT,102) 'DRAIN CURRENT',FLUX2D*FLUNOR,
     1      '(A) MODEL=2-D'
            IF (IMODEL.GE.4) THEN
               WRITE (NUMOUT,'(/)')
               WRITE (NUMOUT,102) 'DRAIN CURRENT',FLUXAV(1)*FLUNOR,
     1         '(A) MODEL=AVL'
               IF (.NOT.LBOTI) THEN
                  WRITE (NUMOUT,102) 'SOURCE CURRENT',
     1            -(FLUXAV(1)+FLUXAV(2))*FLUNOR,'(A)'
                  WRITE (NUMOUT,102) 'BULK CURRENT',FLUXAV(2)*FLUNOR,
     1            '(A)'
               ENDIF
               IF (ITC(1).NE.JSLPRE) THEN
                  WRITE (NUMOUT,'(/)')
                  WRITE (NUMOUT,102) 'DRAIN CURRENT',
     1            (FLUXD(1)-FLUXD(2))*FLUNOR,'(A) MODEL=HOT'
                  IF (.NOT.LBOTI) THEN
                     WRITE (NUMOUT,102) 'SOURCE CURRENT',
     1               -(FLUXB(1)-FLUXB(2)+FLUXD(1)-FLUXD(2))*FLUNOR,'(A)'
                     WRITE (NUMOUT,102) 'BULK CURRENT',
     1               (FLUXB(1)-FLUXB(2))*FLUNOR,'(A)'
                  ENDIF
               ENDIF
            ENDIF
         ENDIF
         IF (LCAP) THEN
            IF (JCAP.EQ.0.OR.JCAP.EQ.1) THEN
               WRITE (NUMOUT,'(/)')
               WRITE (NUMOUT,104) 'S/G',CAPMAT(2,1)*FLUNOR
               WRITE (NUMOUT,104) 'D/G',CAPMAT(3,1)*FLUNOR
               WRITE (NUMOUT,104) 'B/G',CAPMAT(4,1)*FLUNOR
            ENDIF
            IF (JCAP.EQ.0.OR.JCAP.EQ.2) THEN
               WRITE (NUMOUT,'(/)')
               WRITE (NUMOUT,104) 'G/S',CAPMAT(1,2)*FLUNOR
               WRITE (NUMOUT,104) 'D/S',CAPMAT(3,2)*FLUNOR
               WRITE (NUMOUT,104) 'B/S',CAPMAT(4,2)*FLUNOR
            ENDIF
            IF (JCAP.EQ.0.OR.JCAP.EQ.3) THEN
               WRITE (NUMOUT,'(/)')
               WRITE (NUMOUT,104) 'G/D',CAPMAT(1,3)*FLUNOR
               WRITE (NUMOUT,104) 'S/D',CAPMAT(2,3)*FLUNOR
               WRITE (NUMOUT,104) 'B/D',CAPMAT(4,3)*FLUNOR
            ENDIF
            IF (JCAP.EQ.0.OR.JCAP.EQ.4) THEN
               WRITE (NUMOUT,'(/)')
               WRITE (NUMOUT,104) 'G/B',CAPMAT(1,4)*FLUNOR
               WRITE (NUMOUT,104) 'S/B',CAPMAT(2,4)*FLUNOR
               WRITE (NUMOUT,104) 'D/B',CAPMAT(3,4)*FLUNOR
            ENDIF
         ENDIF
      ENDIF

**    ISSUE WARNINGS IF NECESSARY
      IF (IFAIL.EQ.0) THEN
         IF (LSAVEB) CALL BINAER (PAD(JP(1)),PAD(JP(2)),
     1   PAD(JP(3)),PAD(JP(4)),PAD(JP(5)),PAD(JP(9)),PAD(JP(6)))
      ELSEIF (IFAIL.EQ.1) THEN
**       DOPING PROFILE INCONSISTENT
         WRITE (NUMREF,'(10X,A)')
     1   '*** DOPING PROFILE INCONSISTENT'
         WRITE (NUMOUT,'(//10X,A)')
     1   '*** DOPING PROFILE INCONSISTENT'
         LMAJ=.FALSE.
      ELSE
**       ITERATION SEEMS TO DIVERGE
         WRITE (NUMOUT,'(//10X,''*** CALCULATION STOPPED'')')
         IF (IFAIL.EQ.2) THEN
            WRITE (NUMREF,105) 'DRAIN CURRENT'
            WRITE (NUMOUT,105) 'DRAIN CURRENT'
            WRITE (NUMOUT,106)
         ELSEIF (IFAIL.EQ.3) THEN
            WRITE (NUMREF,105) 'THRESHOLD VOLTAGE'
            WRITE (NUMOUT,105) 'THRESHOLD VOLTAGE'
            WRITE (NUMOUT,107)
         ELSEIF (IFAIL.EQ.4) THEN
            WRITE (NUMREF,105) 'DRAIN CURRENT'
            WRITE (NUMOUT,105) 'DRAIN CURRENT'
            WRITE (NUMOUT,107)
         ELSEIF (IFAIL.EQ.5) THEN
            WRITE (NUMREF,105) 'CARRIER TEMPERATURE'
            WRITE (NUMOUT,105) 'CARRIER TEMPERATURE'
            WRITE (NUMOUT,107)
         ENDIF
      ENDIF

**    LATE REFERENCE LINE TO PROPERLY POSITION ERROR MESSAGE
      CALL ZZZSEC (HCPU)
      HCPU=HCPU-CPUTIM
      WRITE (NUMREF,'(/1X,F9.3,1X,A)') HCPU,'OUTPUT PROCESSING'

**    PROPER POINTER ALLOCATION TO PRINT/OMIT INSULATOR DISTRIBUTIONS
      IF (LINS) THEN
         N1SLT=JP(9)
         N1Y=0
         NLY=NYTOT
      ELSE
         N1SLT=JP(9)+NXYOX
         N1Y=NYOX-1
         NLY=NY
      ENDIF

**    PRINT DESIRED DISTRIBUTIONS
*
*     DOPING CONCENTRATION
      IF (NPAGE.LE.3.AND.LDC.AND.ICDON.NE.JSLPRE.AND.ICACC.NE.JSLPRE)
     1THEN
         DO 7705 L=1,NXY
 7705    PAD(L+JP(9)-1)=PAD(L+JP(4)-1)-PAD(L+JP(5)-1)
         CALL PRARAY (NX,NY,PAD(JP(9)),
     1   'DOPING CONCENTRATION','(CM**-3)',
     2   CNOR,NX,NY,PAD(IX1),PAD(IY3),1)
      ENDIF

**    ELECTROSTATIC POTENTIAL
      IF (LPSI.AND.IPSI.NE.JSLPRE) THEN
         DO 7706 L=1,NXYTOT
 7706    PAD(L+JP(9)-1)=PAD(L+JP(1)-1)+US
         CALL PRARAY (NX,NYTOT,PAD(N1SLT),
     1   'ELECTROSTATIC POTENTIAL','(V)',
     2   UTCH,NX,NLY,PAD(IX1),PAD(IY1+N1Y),2)
      ENDIF

**    ELECTRIC FIELD
      IF (LEL.AND.IPSI.NE.JSLPRE) THEN
         CALL DIFFX (PAD(JP(9)),PAD(JP(1)),DX,NX,NYTOT)
         CALL PRARAY (NX,NYTOT,PAD(N1SLT),
     1   'LATERAL FIELD','(V/CM)',
     2   -UTCH/XYNOR,NX-1,NLY,PAD(IX2),PAD(IY1+N1Y),1)
      ENDIF
      IF (LET.AND.IPSI.NE.JSLPRE) THEN
         CALL DIFFY (PAD(JP(9)),PAD(JP(1)),DY,NX,NYTOT)
         CALL PRARAY (NX,NYTOT,PAD(N1SLT),
     1   'TRANSVERSAL FIELD','(V/CM)',
     2   -UTCH/XYNOR,NX,NLY-1,PAD(IX1),PAD(IY2+N1Y),1)
      ENDIF

**    QUASI-FERMI LEVELS
      IF (LPHI.AND.IPSI.NE.JSLPRE) THEN
         IF (LMIN.AND.ICC(1).NE.JSLPRE) THEN
            CALL QUAPHI (PAD(JP(1)+NXYOX),PAD(JP(2)),PAD(JP(9)),1)
            DO 7707 L=1,NXT
 7707       PAD(L+JP(9)-1)=PAD(L+JP(9)-1)+US
            CALL PRARAY (NX,NY,PAD(JP(9)),
     1      TQU(INDMIN),'(V)',
     2      UTCH,NX,NT,PAD(IX1),PAD(IY3),2)
         ENDIF
         IF (LMAJ.AND.ICC(2).NE.JSLPRE) THEN
            CALL QUAPHI (PAD(JP(1)+NXYOX),PAD(JP(3)),PAD(JP(9)),2)
            DO 7708 L=1,NXT
 7708       PAD(L+JP(9)-1)=PAD(L+JP(9)-1)+US
            CALL PRARAY (NX,NY,PAD(JP(9)),
     1      TQU(INDMAJ),'(V)',
     2      UTCH,NX,NT,PAD(IX1),PAD(IY3),2)
         ENDIF
      ENDIF

**    CARRIER CONCENTRATIONS
      IF (LCC) THEN
         IF (LMIN.AND.ICC(1).NE.JSLPRE) THEN
            CALL PRARAY (NX,NY,PAD(JP(2)),
     1      TCR(INDMIN),'(CM**-3)',
     2      CNOR,NX,NT,PAD(IX1),PAD(IY3),1)
         ENDIF
         IF (LMAJ.AND.ICC(2).NE.JSLPRE) THEN
            CALL PRARAY (NX,NY,PAD(JP(3)),
     1      TCR(INDMAJ),'(CM**-3)',
     2      CNOR,NX,NT,PAD(IX1),PAD(IY3),1)
         ENDIF
      ENDIF

**    AVALANCHE GENERATION
      IF (LAVL.AND.IGEN.NE.JSLPRE) THEN
         CALL SLTGET (PAD(JP(9)),IGEN,NXT)
         CALL PRARAY (NX,NY,PAD(JP(9)),
     1   'AVALANCHE GENERATION','(CM**-3/S)',
     2   CNOR,NX,NT,PAD(IX1),PAD(IY3),1)
      ENDIF

**    SPACE CHARGE
      IF (LRHO.AND.ICDON.NE.JSLPRE.AND.ICACC.NE.JSLPRE.AND.
     1ICC(1).NE.JSLPRE.AND.ICC(2).NE.JSLPRE) THEN
         CALL CHARGE (PAD(JP(9)),PAD(JP(2)),PAD(JP(3)),PAD(JP(4)),
     1   PAD(JP(5)),PAD(JP(6)),PAD(JP(6)),.FALSE.)
**       RELOAD TOTAL DOPING CONCENTRATIONS IF PARTIAL IONIZATION
C         IF (ECMED.GE.0) CALL SLTGET (PAD(JP(4)),ICDON,NXY)
C         IF (EAMEV.GE.0) CALL SLTGET (PAD(JP(5)),ICACC,NXY)
         CALL PRARAY (NX,NY,PAD(JP(9)),
     1   'SPACE CHARGE','(AS/CM**3)',
     2    Q*CNORCH,NX,NT,PAD(IX1),PAD(IY3),1)
      ENDIF

**    MINORITY CARRIER CURRENT DENSITY
      IF (LMIN) THEN
         IF (LJL.AND.IJD(1).NE.JSLPRE) THEN
            CALL SLTGET (PAD(JP(9)),IJD(1),NXT-1)
            CALL PRARAY (NX,NY,PAD(JP(9)),
     1      TCL(INDMIN),'(A/CM**2)',
     2      Q*CNORCH*XYNOR,NX-1,NT,PAD(IX2),PAD(IY3),1)
         ENDIF
         IF (LJT.AND.IJD(3).NE.JSLPRE) THEN
            CALL SLTGET (PAD(JP(9)),IJD(3),NXTMX)
            CALL PRARAY (NX,NY,PAD(JP(9)),
     1      TCT(INDMIN),'(A/CM**2)',
     2      Q*CNORCH*XYNOR,NX,NT-1,PAD(IX1),PAD(IY4),1)
         ENDIF
      ENDIF

**    MAJORITY CARRIER CURRENT DENSITY
      IF (LMAJ) THEN
         IF (LJL.AND.IJD(2).NE.JSLPRE) THEN
            CALL SLTGET (PAD(JP(9)),IJD(2),NXT-1)
            CALL PRARAY (NX,NY,PAD(JP(9)),
     1      TCL(INDMAJ),'(A/CM**2)',
     2      -Q*CNORCH*XYNOR,NX-1,NT,PAD(IX2),PAD(IY3),1)
         ENDIF
         IF (LJT.AND.IJD(4).NE.JSLPRE) THEN
            CALL SLTGET (PAD(JP(9)),IJD(4),NXTMX)
            CALL PRARAY (NX,NY,PAD(JP(9)),
     1      TCT(INDMAJ),'(A/CM**2)',
     2      -Q*CNORCH*XYNOR,NX,NT-1,PAD(IX1),PAD(IY4),1)
         ENDIF
      ENDIF

**    CARRIER MOBILITIES
      IF (LMOB) THEN
         IF (LMIN.AND.IDIF(1).NE.JSLPRE) THEN
            CALL SLTGET (PAD(JP(9)),IDIF(1),NXT)
            IF (MODEL.EQ.5.AND.ITC(1).NE.JSLPRE) THEN
               CALL SLTGET (PAD(JP(6)),ITC(1),NXT)
               DO 7709 L=1,NXT
 7709          PAD(L+JP(9)-1)=PAD(L+JP(9)-1)/PAD(L+JP(6)-1)
            ENDIF
            IF (IDIF(3).EQ.JSLPRE) TML(INDMIN)=
     1      TML(INDMIN)(7:23)//'      '
            CALL PRARAY (NX,NY,PAD(JP(9)),
     1      TML(INDMIN),'(CM**2/VS)',
     2      DIFNOR,NX,NT,PAD(IX1),PAD(IY3),3)
            IF (IDIF(3).NE.JSLPRE) THEN
               CALL SLTGET (PAD(JP(9)),IDIF(3),NXT)
               IF (MODEL.EQ.5.AND.ITC(1).NE.JSLPRE) THEN
                  DO 7710 L=1,NXT
 7710             PAD(L+JP(9)-1)=PAD(L+JP(9)-1)/PAD(L+JP(6)-1)
               ENDIF
               CALL PRARAY (NX,NY,PAD(JP(9)),
     1         TMT(INDMIN),'(CM**2/VS)',
     2         DIFNOR,NX,NT,PAD(IX1),PAD(IY3),3)
            ENDIF
         ENDIF
         IF (LMAJ.AND.IDIF(2).NE.JSLPRE) THEN
            CALL SLTGET (PAD(JP(9)),IDIF(2),NXT)
            IF (MODEL.EQ.5.AND.ITC(2).NE.JSLPRE) THEN
               CALL SLTGET (PAD(JP(6)),ITC(2),NXT)
               DO 7711 L=1,NXT
 7711          PAD(L+JP(9)-1)=PAD(L+JP(9)-1)/PAD(L+JP(6)-1)
            ENDIF
            IF (IDIF(4).EQ.JSLPRE) TML(INDMAJ)=
     1      TML(INDMAJ)(7:23)//'      '
            CALL PRARAY (NX,NY,PAD(JP(9)),
     1      TML(INDMAJ),'(CM**2/VS)',
     2      DIFNOR,NX,NT,PAD(IX1),PAD(IY3),3)
            IF (IDIF(4).NE.JSLPRE) THEN
               CALL SLTGET (PAD(JP(9)),IDIF(4),NXT)
               IF (MODEL.EQ.5.AND.ITC(2).NE.JSLPRE) THEN
                  DO 7712 L=1,NXT
 7712             PAD(L+JP(9)-1)=PAD(L+JP(9)-1)/PAD(L+JP(6)-1)
               ENDIF
               CALL PRARAY (NX,NY,PAD(JP(9)),
     1         TMT(INDMAJ),'(CM**2/VS)',
     2         DIFNOR,NX,NT,PAD(IX1),PAD(IY3),3)
            ENDIF
         ENDIF
      ENDIF

**    CARRIER TEMPERATURES
      IF (LTC) THEN
         IF (LMIN.AND.ITC(1).NE.JSLPRE) THEN
            CALL SLTGET (PAD(JP(9)),ITC(1),NXT)
            CALL PRARAY (NX,NY,PAD(JP(9)),
     1      TUT(INDMIN),'(K)',
     2      SIMTEM,NX,NT,PAD(IX1),PAD(IY3),2)
         ENDIF
         IF (LMAJ.AND.ITC(2).NE.JSLPRE) THEN
            CALL SLTGET (PAD(JP(9)),ITC(2),NXT)
            CALL PRARAY (NX,NY,PAD(JP(9)),
     1      TUT(INDMAJ),'(K)',
     2      SIMTEM,NX,NT,PAD(IX1),PAD(IY3),2)
         ENDIF
      ENDIF

 101  FORMAT(20X,A,T41,'= ',F10.2,1X,A)
 102  FORMAT(20X,A,T41,'= ',1PE10.2,1X,A)
 103  FORMAT(20X,A,T41,'= ',F10.4,1X,A)
 104  FORMAT(20X,'CAPACITY  ',A,T41,'= ',1PE10.2,' (F)')
 105  FORMAT(10X,'*** ITERATION FOR THE ',A,' SEEMS TO DIVERGE')
 106  FORMAT(10X,'*** CYCLE LIMIT REACHED')
 107  FORMAT(10X,'*** JOB COULD BE RESTARTED WITH *PHYSCK=NO* OPTION')
      END
